
# This file was generated by Hermes Parser Generator on Wed Dec 19 03:32:57 2018
# 
# Hermes command: hermes generate wdl/versions/development/parsers/grammar.hgr --language=python --name=development --header --directory wdl_parser
# Run from: .. (relative to this file)
# Hermes version: hermes-parser 2.0rc6
# 
# !!! DO NOT CHANGE THIS FILE DIRECTLY !!!
# 
# If you wish to change something in this file, either change the grammar and
# re-generate this file, or change the templates in Hermes and regenerate.
# See the Hermes repository: http://github.com/scottfrazer/hermes
import sys
import os
import re
import base64
import argparse
from collections import OrderedDict
# Common Code #
def parse_tree_string(parsetree, indent=None, b64_source=True, indent_level=0, debug=False):
    indent_str = (' ' * indent * indent_level) if indent else ''
    if isinstance(parsetree, ParseTree):
        children = [parse_tree_string(child, indent, b64_source, indent_level+1, debug) for child in parsetree.children]
        debug_str = parsetree.debug_str() if debug else ''
        if indent is None or len(children) == 0:
            return '{0}({1}: {2}{3})'.format(indent_str, parsetree.nonterminal, debug_str, ', '.join(children))
        else:
            return '{0}({1}:{2}\n{3}\n{4})'.format(
                indent_str,
                parsetree.nonterminal,
                debug_str,
                ',\n'.join(children),
                indent_str
            )
    elif isinstance(parsetree, Terminal):
        return indent_str + parsetree.dumps(b64_source=b64_source)
def ast_string(ast, indent=None, b64_source=True, indent_level=0):
    indent_str = (' ' * indent * indent_level) if indent else ''
    next_indent_str = (' ' * indent * (indent_level+1)) if indent else ''
    if isinstance(ast, Ast):
        children = OrderedDict([(k, ast_string(v, indent, b64_source, indent_level+1)) for k, v in ast.attributes.items()])
        if indent is None:
            return '({0}: {1})'.format(
                ast.name,
                ', '.join('{0}={1}'.format(k, v) for k, v in children.items())
            )
        else:
            return '({0}:\n{1}\n{2})'.format(
                ast.name,
                ',\n'.join(['{0}{1}={2}'.format(next_indent_str, k, v) for k, v in children.items()]),
                indent_str
            )
    elif isinstance(ast, list):
        children = [ast_string(element, indent, b64_source, indent_level+1) for element in ast]
        if indent is None or len(children) == 0:
            return '[{0}]'.format(', '.join(children))
        else:
            return '[\n{1}\n{0}]'.format(
                indent_str,
                ',\n'.join(['{0}{1}'.format(next_indent_str, child) for child in children]),
            )
    elif isinstance(ast, Terminal):
        return ast.dumps(b64_source=b64_source)
class Terminal:
  def __init__(self, id, str, source_string, resource, line, col):
      self.__dict__.update(locals())
  def getId(self):
      return self.id
  def ast(self):
      return self
  def dumps(self, b64_source=True, **kwargs):
      source_string = base64.b64encode(self.source_string.encode('utf-8')).decode('utf-8') if b64_source else self.source_string
      return '<{resource}:{line}:{col} {terminal} "{source}">'.format(
          resource=self.resource,
          line=self.line,
          col=self.col,
          terminal=self.str,
          source=source_string
      )
  def __str__(self):
      return self.dumps()
class NonTerminal():
  def __init__(self, id, str):
    self.__dict__.update(locals())
    self.list = False
  def __str__(self):
    return self.str
class AstTransform:
  pass
class AstTransformSubstitution(AstTransform):
  def __init__(self, idx):
    self.__dict__.update(locals())
  def __repr__(self):
    return '$' + str(self.idx)
  def __str__(self):
    return self.__repr__()
class AstTransformNodeCreator(AstTransform):
  def __init__( self, name, parameters ):
    self.__dict__.update(locals())
  def __repr__( self ):
    return self.name + '( ' + ', '.join(['%s=$%s' % (k,str(v)) for k,v in self.parameters.items()]) + ' )'
  def __str__(self):
    return self.__repr__()
class AstList(list):
  def ast(self):
      retval = []
      for ast in self:
          retval.append(ast.ast())
      return retval
  def dumps(self, indent=None, b64_source=True):
      args = locals()
      del args['self']
      return ast_string(self, **args)
class ParseTree():
  def __init__(self, nonterminal):
      self.__dict__.update(locals())
      self.children = []
      self.astTransform = None
      self.isExpr = False
      self.isNud = False
      self.isPrefix = False
      self.isInfix = False
      self.nudMorphemeCount = 0
      self.isExprNud = False # true for rules like _expr := {_expr} + {...}
      self.list_separator_id = None
      self.list = False
  def debug_str(self):
      from copy import deepcopy
      def h(v):
          if v == False or v is None:
              return str(v)
          from xtermcolor import colorize
          return colorize(str(v), ansi=190)
      d = deepcopy(self.__dict__)
      for key in ['self', 'nonterminal', 'children']:
          del d[key]
      f = {k: v for k, v in d.items() if v != False and v is not None}
      return ' [{}]'.format(', '.join(['{}={}'.format(k,h(v)) for k,v in f.items()]))
  def add(self, tree):
      self.children.append( tree )
  def is_compound_nud(self):
      return isinstance(self.children[0], ParseTree) and \
             self.children[0].isNud and \
             not self.children[0].isPrefix and \
             not self.isExprNud and \
             not self.isInfix
  def ast(self):
      if self.list == True:
          r = AstList()
          if len(self.children) == 0:
              return r
          for child in self.children:
              if isinstance(child, Terminal) and self.list_separator_id is not None and child.id == self.list_separator_id:
                  continue
              r.append(child.ast())
          return r
      elif self.isExpr:
          if isinstance(self.astTransform, AstTransformSubstitution):
              return self.children[self.astTransform.idx].ast()
          elif isinstance(self.astTransform, AstTransformNodeCreator):
              parameters = OrderedDict()
              for name, idx in self.astTransform.parameters.items():
                  if idx == '$':
                      child = self.children[0]
                  elif self.is_compound_nud():
                      if idx < self.children[0].nudMorphemeCount:
                          child = self.children[0].children[idx]
                      else:
                          index = idx - self.children[0].nudMorphemeCount + 1
                          child = self.children[index]
                  elif len(self.children) == 1 and not isinstance(self.children[0], ParseTree) and not isinstance(self.children[0], list):
                      return self.children[0]
                  else:
                      child = self.children[idx]
                  parameters[name] = child.ast()
              return Ast(self.astTransform.name, parameters)
      else:
          if isinstance(self.astTransform, AstTransformSubstitution):
              return self.children[self.astTransform.idx].ast()
          elif isinstance(self.astTransform, AstTransformNodeCreator):
              parameters = OrderedDict()
              for name, idx in self.astTransform.parameters.items():
                  parameters[name] = self.children[idx].ast()
              return Ast(self.astTransform.name, parameters)
          elif len(self.children):
              return self.children[0].ast()
          else:
              return None
  def dumps(self, indent=None, b64_source=True, debug=False):
      args = locals()
      del args['self']
      return parse_tree_string(self, **args)
class Ast():
    def __init__(self, name, attributes):
        self.__dict__.update(locals())
    def attr(self, attr):
        return self.attributes[attr]
    def dumps(self, indent=None, b64_source=True):
        args = locals()
        del args['self']
        return ast_string(self, **args)
class SyntaxError(Exception):
    def __init__(self, message):
        self.__dict__.update(locals())
    def __str__(self):
        return self.message
class TokenStream(list):
    def __init__(self, arg=[]):
        super(TokenStream, self).__init__(arg)
        self.index = 0
    def advance(self):
        self.index += 1
        return self.current()
    def last(self):
        return self[-1]
    def current(self):
        try:
            return self[self.index]
        except IndexError:
            return None
class DefaultSyntaxErrorHandler:
    def __init__(self):
        self.errors = []
    def _error(self, string):
        error = SyntaxError(string)
        self.errors.append(error)
        return error
    def unexpected_eof(self):
        return self._error("Error: unexpected end of file")
    def excess_tokens(self):
        return self._error("Finished parsing without consuming all tokens.")
    def unexpected_symbol(self, nonterminal, actual_terminal, expected_terminals, rule):
        return self._error("Unexpected symbol (line {line}, col {col}) when parsing parse_{nt}.  Expected {expected}, got {actual}.".format(
            line=actual_terminal.line,
            col=actual_terminal.col,
            nt=nonterminal,
            expected=', '.join(expected_terminals),
            actual=actual_terminal
        ))
    def no_more_tokens(self, nonterminal, expected_terminal, last_terminal):
        return self._error("No more tokens.  Expecting " + expected_terminal)
    def invalid_terminal(self, nonterminal, invalid_terminal):
        return self._error("Invalid symbol ID: {} ({})".format(invalid_terminal.id, invalid_terminal.string))
    def unrecognized_token(self, string, line, col):
        lines = string.split('\n')
        bad_line = lines[line-1]
        return self._error('Unrecognized token on line {}, column {}:\n\n{}\n{}'.format(
            line, col, bad_line, ''.join([' ' for x in range(col-1)]) + '^'
        ))
    def missing_list_items(self, method, required, found, last):
        return self._error("List for {} requires {} items but only {} were found.".format(method, required, found))
    def missing_terminator(self, method, terminator, last):
        return self._error("List for "+method+" is missing a terminator")
class ParserContext:
  def __init__(self, tokens, errors):
    self.__dict__.update(locals())
    self.nonterminal_string = None
    self.rule_string = None
# Parser Code #
terminals = {
    0: 'dot',
    1: 'gteq',
    2: 'raw_cmd_end',
    3: 'object',
    4: 'gt',
    5: 'task',
    6: 'struct',
    7: 'version_name',
    8: 'lparen',
    9: 'colon',
    10: 'type',
    11: 'percent',
    12: 'identifier',
    13: 'fqn',
    14: 'cmd_attr_hint',
    15: 'slash',
    16: 'float',
    17: 'meta',
    18: 'expression_placeholder_end',
    19: 'e',
    20: 'expression_placeholder_start',
    21: 'as',
    22: 'integer',
    23: 'alias',
    24: 'runtime',
    25: 'scatter',
    26: 'lbrace',
    27: 'equal',
    28: 'parameter_meta',
    29: 'else',
    30: 'plus',
    31: 'version',
    32: 'lt',
    33: 'meta_value',
    34: 'double_equal',
    35: 'then',
    36: 'string',
    37: 'quote',
    38: 'workflow',
    39: 'rsquare',
    40: 'output',
    41: 'call',
    42: 'asterisk',
    43: 'input',
    44: 'not',
    45: 'boolean',
    46: 'not_equal',
    47: 'lsquare',
    48: 'in',
    49: 'null',
    50: 'qmark',
    51: 'escape',
    52: 'raw_cmd_start',
    53: 'rparen',
    54: 'type_e',
    55: 'lteq',
    56: 'double_ampersand',
    57: 'if',
    58: 'dash',
    59: 'raw_command',
    60: 'comma',
    61: 'double_pipe',
    62: 'import',
    63: 'cmd_part',
    64: 'rbrace',
    'dot': 0,
    'gteq': 1,
    'raw_cmd_end': 2,
    'object': 3,
    'gt': 4,
    'task': 5,
    'struct': 6,
    'version_name': 7,
    'lparen': 8,
    'colon': 9,
    'type': 10,
    'percent': 11,
    'identifier': 12,
    'fqn': 13,
    'cmd_attr_hint': 14,
    'slash': 15,
    'float': 16,
    'meta': 17,
    'expression_placeholder_end': 18,
    'e': 19,
    'expression_placeholder_start': 20,
    'as': 21,
    'integer': 22,
    'alias': 23,
    'runtime': 24,
    'scatter': 25,
    'lbrace': 26,
    'equal': 27,
    'parameter_meta': 28,
    'else': 29,
    'plus': 30,
    'version': 31,
    'lt': 32,
    'meta_value': 33,
    'double_equal': 34,
    'then': 35,
    'string': 36,
    'quote': 37,
    'workflow': 38,
    'rsquare': 39,
    'output': 40,
    'call': 41,
    'asterisk': 42,
    'input': 43,
    'not': 44,
    'boolean': 45,
    'not_equal': 46,
    'lsquare': 47,
    'in': 48,
    'null': 49,
    'qmark': 50,
    'escape': 51,
    'raw_cmd_start': 52,
    'rparen': 53,
    'type_e': 54,
    'lteq': 55,
    'double_ampersand': 56,
    'if': 57,
    'dash': 58,
    'raw_command': 59,
    'comma': 60,
    'double_pipe': 61,
    'import': 62,
    'cmd_part': 63,
    'rbrace': 64,
}
# table[nonterminal][terminal] = rule
table = [
    [-1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1],
    [-1, -1, -1, -1, -1, -1, 8, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1],
    [-1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1],
    [-1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1],
    [-1, -1, -1, -1, -1, 19, 19, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 18, -1, 19, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 19, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 19, -1, -1],
    [-1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 17, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 16, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 16, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1],
    [-1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 9, -1, 9, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 9, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1],
    [-1, -1, -1, -1, -1, 4, 5, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 3, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1],
    [-1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 13, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1],
    [-1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 79, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1],
    [-1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 47, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1],
    [-1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 45, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1],
    [-1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1],
    [-1, -1, -1, -1, -1, 25, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1],
    [-1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 14, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 15, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1],
    [-1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 21, -1, -1],
    [-1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1],
    [-1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 41, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1],
    [-1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1],
    [-1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1],
    [-1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 42, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1],
    [-1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 58, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1],
    [-1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1],
    [-1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 80, -1, -1, -1, -1, -1, -1, -1],
    [-1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1],
    [-1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 49, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1],
    [-1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 22, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1],
    [-1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 32, -1, 32, -1, -1, -1, -1, 31, -1, -1, -1, -1, -1, -1, 29, -1, -1, -1, 30, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 28, -1, -1, 27, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 32, -1, -1, -1, -1, 26, -1, -1, -1, -1, -1],
    [-1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 52, -1, 52, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 51, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 52, -1, -1, -1, -1, -1, -1, -1, -1, -1, 52],
    [-1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1],
    [-1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1],
    [-1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1],
    [-1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 78, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1],
    [-1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1],
    [-1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 23, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1],
    [-1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 44, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1],
    [-1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 81, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1],
    [-1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 39, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1],
    [-1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1],
    [-1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1],
    [-1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1],
    [-1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 11, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1],
    [-1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 36, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 35, -1],
    [-1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 2, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1],
    [-1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1],
    [-1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 38, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1],
    [-1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 59, -1, 59, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 59, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1],
    [-1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1],
    [-1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1],
    [-1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 82, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1],
    [-1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1],
    [-1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 46, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1],
    [-1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1],
    [-1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1],
    [-1, -1, -1, 56, -1, -1, -1, -1, 56, -1, -1, -1, 56, -1, -1, -1, 56, -1, -1, 56, -1, -1, 56, -1, -1, -1, 56, -1, -1, -1, 56, -1, -1, -1, -1, -1, -1, 56, -1, -1, -1, -1, -1, -1, 56, 56, -1, 56, -1, -1, -1, -1, -1, -1, -1, -1, -1, 56, 56, -1, -1, -1, -1, -1, -1],
    [-1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 63, -1, 63, -1, -1, -1, -1, 69, -1, -1, -1, -1, -1, -1, -1, 65, -1, -1, 68, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 67, 62, -1, 66, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 63, -1, -1, 64, -1, -1, -1, -1, -1, -1, -1],
    [-1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 55, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1],
    [-1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 54, -1, 54, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 54, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1],
    [-1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1],
    [-1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 61, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1],
    [-1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 74, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1],
    [-1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 77, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1],
    [-1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 83, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1],
    [-1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 71, -1, 71, -1, -1, -1, -1, 71, -1, -1, -1, 70, -1, -1, -1, 71, 71, -1, 71, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 71, 71, -1, 71, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 71, -1, -1, 71, -1, -1, -1, -1, -1, -1, 71],
    [-1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1],
    [-1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 73, -1, 73, -1, -1, -1, -1, 73, -1, -1, -1, -1, -1, -1, -1, 73, 72, -1, 73, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 73, 73, -1, 73, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 73, -1, -1, 73, -1, -1, -1, -1, -1, -1, 73],
    [-1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 50, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1],
    [-1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 76, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1],
    [-1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 34, -1, -1, -1, -1, -1],
    [-1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 53, -1, 53, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 53, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1],
    [-1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 6, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1],
]
nonterminal_first = {
    65: [10, 54, 12, -1],
    66: [6],
    67: [49, 22, 47, 33, 26, 45, 16, 37],
    68: [3, 8, 37, 44, 12, 45, 16, 47, 19, -1, 57, 22, 26, 58, 30],
    69: [21, -1],
    70: [36, 51, 20],
    71: [10, 54, 12],
    72: [5, 6, 38],
    73: [37],
    74: [17],
    75: [28],
    76: [12],
    77: [33, 37, 45, 16, 47, 49, -1, 22, 26],
    78: [5],
    79: [36, 51],
    80: [62],
    81: [-1, 12],
    82: [43],
    83: [51, 36, -1, 20],
    84: [10, 54, 12, -1],
    85: [24],
    86: [40],
    87: [25, 17, 54, -1, 57, 10, 41, 12, 43, 28, 40],
    88: [57],
    89: [3, 19, 8, 16, 37, 58, 57, 22, 44, 12, 26, 45, 47, 30],
    90: [26],
    91: [21],
    92: [17, 43, 54, 10, 12, 24, 59, 28, 40],
    93: [-1, 27],
    94: [10, 54, 12, -1],
    95: [36, -1, 51],
    96: [6, -1, 38, 5],
    97: [28],
    98: [-1, 62],
    99: [23],
    100: [26],
    101: [25],
    102: [14],
    103: [-1, 14],
    104: [10, 54, 12, -1],
    105: [-1, 12],
    106: [37],
    107: [20, 63],
    108: [31],
    109: [-1, 12],
    110: [20],
    111: [10, 54, 12],
    112: [-1, 12],
    113: [17, 43, 54, -1, 10, 12, 24, 59, 28, 40],
    114: [12],
    115: [-1, 12],
    116: [17],
    117: [10, 54, 12],
    118: [-1, 23],
    119: [47, 3, 19, 8, 37, 58, 57, 22, 44, 12, 26, 45, 16, 30],
    120: [43, 17, 54, 57, 10, 41, 12, 25, 28, 40],
    121: [27],
    122: [10, 54, 12],
    123: [20, -1, 63],
    124: [38],
    125: [41],
    126: [21],
    127: [12],
    128: [21, -1],
    129: [3, 8, 37, 44, 12, 45, 47, 16, 19, -1, 57, 22, 26, 58, 30],
    130: [26, -1],
    131: [12],
    132: [26],
    133: [59],
    134: [10, 54, 12],
    135: [31],
}
nonterminal_follow = {
    65: [64],
    66: [5, 6, -1, 38],
    67: [39, 12, 60, 64],
    68: [64],
    69: [23, 5, 6, 62, -1, 38],
    70: [51, 36, 20, 37],
    71: [10, 54, 12, 64],
    72: [5, 6, -1, 38],
    73: [0, 1, 3, 4, 8, 9, 10, 12, 14, 15, 16, 17, 18, 19, 22, 59, 24, 25, 26, 28, 29, 30, 32, 35, 34, 37, 39, 42, 44, 41, 43, 46, 45, 47, 54, 53, 55, 56, 57, 11, 60, 61, 40, 58, 64],
    74: [10, 41, 12, 43, 17, 54, 57, 25, 28, 40, 64],
    75: [17, 43, 54, 10, 12, 24, 59, 28, 40, 64],
    76: [64, 12],
    77: [39],
    78: [5, 6, -1, 38],
    79: [51, 36, 20, 37],
    80: [5, 6, 62, -1, 38],
    81: [64],
    82: [10, 41, 12, 43, 17, 54, 24, 57, 25, 59, 28, 40, 64],
    83: [37],
    84: [64],
    85: [17, 43, 54, 10, 12, 24, 59, 28, 40, 64],
    86: [10, 41, 12, 43, 17, 54, 24, 57, 25, 59, 28, 40, 64],
    87: [64],
    88: [10, 41, 12, 43, 17, 54, 57, 25, 28, 40, 64],
    89: [0, 1, 3, 4, 8, 9, 10, 12, 14, 15, 16, 17, 18, 19, 22, 59, 24, 25, 26, 28, 29, 30, 32, 35, 34, 37, 39, 42, 44, 41, 43, 46, 45, 47, 54, 53, 55, 56, 57, 11, 60, 61, 40, 58, 64],
    90: [10, 41, 12, 43, 17, 54, 24, 57, 25, 59, 28, 40, 64],
    91: [5, 6, 38, 23, 62, -1],
    92: [17, 43, 54, 10, 12, 24, 59, 28, 40, 64],
    93: [10, 54, 12, 64],
    94: [39],
    95: [37],
    96: [-1],
    97: [10, 41, 12, 43, 17, 54, 57, 25, 28, 40, 64],
    98: [6, 5, -1, 38],
    99: [5, 6, 38, 23, 62, -1],
    100: [17, 43, 54, 10, 12, 24, 59, 28, 40, 64],
    101: [10, 41, 12, 43, 17, 54, 57, 25, 28, 40, 64],
    102: [3, 8, 37, 44, 12, 14, 45, 47, 16, 19, 57, 22, 26, 58, 30],
    103: [3, 19, 8, 16, 37, 58, 57, 22, 44, 12, 26, 45, 47, 30],
    104: [64],
    105: [64],
    106: [5, 6, 38, 21, 39, 12, 60, 62, -1, 64],
    107: [63, 2, 20],
    108: [-1],
    109: [64],
    110: [63, 2, 51, 36, 20, 37],
    111: [10, 54, 12, 64],
    112: [64],
    113: [64],
    114: [60, 64],
    115: [64],
    116: [17, 43, 54, 10, 12, 24, 59, 28, 40, 64],
    117: [39, 60, 12],
    118: [5, 6, 62, -1, 38],
    119: [60, 64],
    120: [10, 41, 12, 43, 17, 54, 57, 25, 28, 40, 64],
    121: [25, 10, 41, 12, 43, 17, 54, 57, 24, 59, 28, 40, 64],
    122: [10, 41, 12, 43, 17, 54, 24, 57, 25, 59, 28, 40, 64],
    123: [2],
    124: [5, 6, -1, 38],
    125: [10, 41, 12, 43, 17, 54, 57, 25, 28, 40, 64],
    126: [10, 41, 12, 43, 17, 54, 57, 25, 26, 28, 40, 64],
    127: [60, 64],
    128: [10, 41, 12, 43, 17, 54, 57, 25, 26, 28, 40, 64],
    129: [39, 53],
    130: [10, 41, 12, 43, 17, 54, 57, 25, 28, 40, 64],
    131: [60, 64, 12],
    132: [10, 41, 12, 43, 17, 54, 57, 25, 28, 40, 64],
    133: [17, 43, 54, 10, 12, 24, 59, 28, 40, 64],
    134: [10, 54, 12, 64],
    135: [62, -1],
}
rule_first = {
    0: [-1, 62],
    1: [5, 6, -1, 38],
    2: [31],
    3: [38],
    4: [5],
    5: [6],
    6: [31],
    7: [-1, 10, 54, 12],
    8: [6],
    9: [10, 54, 12],
    10: [36, -1, 51],
    11: [37],
    12: [36, -1, 51, 20],
    13: [37],
    14: [36],
    15: [51],
    16: [36, 51],
    17: [20],
    18: [21],
    19: [-1],
    20: [-1, 23],
    21: [62],
    22: [21],
    23: [23],
    24: [17, 43, 54, -1, 10, 12, 24, 59, 28, 40],
    25: [5],
    26: [59],
    27: [43],
    28: [40],
    29: [24],
    30: [28],
    31: [17],
    32: [10, 54, 12],
    33: [20, -1, 63],
    34: [59],
    35: [63],
    36: [20],
    37: [-1, 14],
    38: [20],
    39: [14],
    40: [-1, 10, 54, 12],
    41: [43],
    42: [24],
    43: [-1, 12],
    44: [26],
    45: [12],
    46: [17],
    47: [28],
    48: [-1, 12],
    49: [26],
    50: [12],
    51: [27],
    52: [-1],
    53: [10, 54, 12],
    54: [10, 54, 12],
    55: [27],
    56: [3, 19, 8, 16, 37, 58, 57, 22, 44, 12, 26, 45, 47, 30],
    57: [-1, 10, 54, 12],
    58: [40],
    59: [10, 54, 12],
    60: [43, 17, 54, -1, 57, 10, 41, 12, 25, 28, 40],
    61: [38],
    62: [41],
    63: [10, 54, 12],
    64: [57],
    65: [25],
    66: [43],
    67: [40],
    68: [28],
    69: [17],
    70: [21],
    71: [-1],
    72: [26],
    73: [-1],
    74: [41],
    75: [-1, 12],
    76: [26],
    77: [21],
    78: [28],
    79: [17],
    80: [57],
    81: [25],
    82: [12],
    83: [12],
    84: [37],
    85: [45],
    86: [22],
    87: [16],
    88: [49],
    89: [49, 33, -1, 37, 22, 16, 26, 45, 47],
    90: [47],
    91: [-1, 12],
    92: [26],
    93: [-1, 10, 54, 12],
    94: [10],
    95: [10],
    96: [10],
    97: [10],
    98: [12],
    99: [3, 19, 8, 16, 37, 58, 57, 22, 44, 12, 26, 45, 47, 30],
    100: [3, 19, 8, 16, 37, 58, 57, 22, 44, 12, 26, 45, 47, 30],
    101: [3, 19, 8, 16, 37, 58, 57, 22, 44, 12, 26, 45, 47, 30],
    102: [3, 19, 8, 16, 37, 58, 57, 22, 44, 12, 26, 45, 47, 30],
    103: [3, 19, 8, 16, 37, 58, 57, 22, 44, 12, 26, 45, 47, 30],
    104: [3, 19, 8, 16, 37, 58, 57, 22, 44, 12, 26, 45, 47, 30],
    105: [3, 19, 8, 16, 37, 58, 57, 22, 44, 12, 26, 45, 47, 30],
    106: [3, 19, 8, 16, 37, 58, 57, 22, 44, 12, 26, 45, 47, 30],
    107: [3, 19, 8, 16, 37, 58, 57, 22, 44, 12, 26, 45, 47, 30],
    108: [3, 19, 8, 16, 37, 58, 57, 22, 44, 12, 26, 45, 47, 30],
    109: [3, 19, 8, 16, 37, 58, 57, 22, 44, 12, 26, 45, 47, 30],
    110: [3, 19, 8, 16, 37, 58, 57, 22, 44, 12, 26, 45, 47, 30],
    111: [3, 19, 8, 16, 37, 58, 57, 22, 44, 12, 26, 45, 47, 30],
    112: [44],
    113: [30],
    114: [58],
    115: [3, 19, 8, -1, 16, 37, 58, 57, 22, 44, 12, 26, 45, 47, 30],
    116: [12],
    117: [3, 19, 8, 16, 37, 58, 57, 22, 44, 12, 26, 45, 47, 30],
    118: [3, 19, 8, 16, 37, 58, 57, 22, 44, 12, 26, 45, 47, 30],
    119: [-1, 12],
    120: [3],
    121: [47],
    122: [47, 3, 19, 8, -1, 37, 58, 57, 22, 44, 12, 26, 45, 16, 30],
    123: [26],
    124: [8],
    125: [57],
    126: [37],
    127: [12],
    128: [45],
    129: [22],
    130: [16],
}
nonterminal_rules = {
    65: [
        "$_gen14 = list($output_kv)",
    ],
    66: [
        "$struct = :struct :identifier :lbrace $_gen2 :rbrace -> Struct( name=$1, entries=$3 )",
    ],
    67: [
        "$meta_value = $static_string",
        "$meta_value = :boolean",
        "$meta_value = :integer",
        "$meta_value = :float",
        "$meta_value = :null",
        "$meta_value = :lsquare $_gen19 :rsquare -> MetaArray( values=$1 )",
        "$meta_value = :lbrace $_gen20 :rbrace -> MetaObject( map=$1 )",
    ],
    68: [
        "$_gen24 = list($map_kv, :comma)",
    ],
    69: [
        "$_gen5 = $import_namespace",
        "$_gen5 = :_empty",
    ],
    70: [
        "$string_piece = $static_string_piece",
        "$string_piece = $expression_placeholder",
    ],
    71: [
        "$struct_declaration = $type_e :identifier -> StructEntry( type=$0, name=$1 )",
    ],
    72: [
        "$file_body_element = $workflow",
        "$file_body_element = $task",
        "$file_body_element = $struct",
    ],
    73: [
        "$string_literal = :quote $_gen4 :quote -> StringLiteral( pieces=$1 )",
    ],
    74: [
        "$wf_meta = :meta $meta_map -> Meta( map=$1 )",
    ],
    75: [
        "$parameter_meta = :parameter_meta $meta_map -> ParameterMeta( map=$1 )",
    ],
    76: [
        "$kv = :identifier :colon $e -> RuntimeAttribute( key=$0, value=$2 )",
    ],
    77: [
        "$_gen19 = list($meta_value, :comma)",
    ],
    78: [
        "$task = :task :identifier :lbrace $_gen7 :rbrace -> Task( name=$1, sections=$3 )",
    ],
    79: [
        "$static_string_piece = :string",
        "$static_string_piece = :escape",
    ],
    80: [
        "$import = :import $static_string $_gen5 $_gen6 -> Import( uri=$1, namespace=$2, aliases=$3 )",
    ],
    81: [
        "$_gen11 = list($kv)",
    ],
    82: [
        "$inputs = :input :lbrace $_gen10 :rbrace -> Inputs( inputs=$2 )",
    ],
    83: [
        "$_gen4 = list($string_piece)",
    ],
    84: [
        "$_gen2 = list($struct_declaration)",
    ],
    85: [
        "$runtime = :runtime $rt_map -> Runtime( map=$1 )",
    ],
    86: [
        "$outputs = :output :lbrace $_gen14 :rbrace -> Outputs( outputs=$2 )",
    ],
    87: [
        "$_gen15 = list($wf_body_element)",
    ],
    88: [
        "$if_stmt = :if :lparen $e :rparen :lbrace $_gen15 :rbrace -> If( expression=$2, body=$5 )",
    ],
    89: [
        "$e = $e :double_pipe $e -> LogicalOr( lhs=$0, rhs=$2 )",
        "$e = $e :double_ampersand $e -> LogicalAnd( lhs=$0, rhs=$2 )",
        "$e = $e :double_equal $e -> Equals( lhs=$0, rhs=$2 )",
        "$e = $e :not_equal $e -> NotEquals( lhs=$0, rhs=$2 )",
        "$e = $e :lt $e -> LessThan( lhs=$0, rhs=$2 )",
        "$e = $e :lteq $e -> LessThanOrEqual( lhs=$0, rhs=$2 )",
        "$e = $e :gt $e -> GreaterThan( lhs=$0, rhs=$2 )",
        "$e = $e :gteq $e -> GreaterThanOrEqual( lhs=$0, rhs=$2 )",
        "$e = $e :plus $e -> Add( lhs=$0, rhs=$2 )",
        "$e = $e :dash $e -> Subtract( lhs=$0, rhs=$2 )",
        "$e = $e :asterisk $e -> Multiply( lhs=$0, rhs=$2 )",
        "$e = $e :slash $e -> Divide( lhs=$0, rhs=$2 )",
        "$e = $e :percent $e -> Remainder( lhs=$0, rhs=$2 )",
        "$e = :not $e -> LogicalNot( expression=$1 )",
        "$e = :plus $e -> UnaryPlus( expression=$1 )",
        "$e = :dash $e -> UnaryNegation( expression=$1 )",
        "$e = :identifier <=> :lparen $_gen22 :rparen -> FunctionCall( name=$0, params=$2 )",
        "$e = $e <=> :lsquare $e :rsquare -> ArrayOrMapLookup( lhs=$0, rhs=$2 )",
        "$e = $e <=> :dot :identifier -> MemberAccess( value=$0, member=$2 )",
        "$e = :object :lbrace $_gen23 :rbrace -> ObjectLiteral( map=$2 )",
        "$e = :lsquare $_gen22 :rsquare -> ArrayLiteral( values=$1 )",
        "$e = :lbrace $_gen24 :rbrace -> MapLiteral( map=$1 )",
        "$e = :lparen $_gen22 :rparen -> TupleLiteral( values=$1 )",
        "$e = :if $e :then $e :else $e -> TernaryIf( cond=$1, iftrue=$3, iffalse=$5 )",
        "$e = $string_literal",
        "$e = :identifier",
        "$e = :boolean",
        "$e = :integer",
        "$e = :float",
    ],
    90: [
        "$meta_map = :lbrace $_gen12 :rbrace -> $1",
    ],
    91: [
        "$import_namespace = :as :identifier -> $1",
    ],
    92: [
        "$task_sections = $command",
        "$task_sections = $inputs",
        "$task_sections = $outputs",
        "$task_sections = $runtime",
        "$task_sections = $parameter_meta",
        "$task_sections = $meta",
        "$task_sections = $declaration",
    ],
    93: [
        "$_gen13 = $setter",
        "$_gen13 = :_empty",
    ],
    94: [
        "$_gen21 = list($type_e, :comma)",
    ],
    95: [
        "$_gen3 = list($static_string_piece)",
    ],
    96: [
        "$_gen1 = list($file_body_element)",
    ],
    97: [
        "$wf_parameter_meta = :parameter_meta $meta_map -> ParameterMeta( map=$1 )",
    ],
    98: [
        "$_gen0 = list($import)",
    ],
    99: [
        "$import_alias = :alias :identifier :as :identifier -> ImportAlias( old_name=$1, new_name=$3 )",
    ],
    100: [
        "$rt_map = :lbrace $_gen11 :rbrace -> $1",
    ],
    101: [
        "$scatter = :scatter :lparen :identifier :in $e :rparen :lbrace $_gen15 :rbrace -> Scatter( item=$2, collection=$4, body=$7 )",
    ],
    102: [
        "$expression_placeholder_kv = :cmd_attr_hint :identifier :equal $e -> ExpressionPlaceholderAttr( key=$1, value=$3 )",
    ],
    103: [
        "$_gen9 = list($expression_placeholder_kv)",
    ],
    104: [
        "$_gen10 = list($input_declaration)",
    ],
    105: [
        "$_gen23 = list($object_kv, :comma)",
    ],
    106: [
        "$static_string = :quote $_gen3 :quote -> StaticString( value=$1 )",
    ],
    107: [
        "$command_part = :cmd_part",
        "$command_part = $expression_placeholder",
    ],
    108: [
        "$document = $version $_gen0 $_gen1 -> Draft3File( version=$0, imports=$1, body=$2 )",
    ],
    109: [
        "$_gen12 = list($meta_kv)",
    ],
    110: [
        "$expression_placeholder = :expression_placeholder_start $_gen9 $e :expression_placeholder_end -> ExpressionPlaceholder( attributes=$1, expr=$2 )",
    ],
    111: [
        "$output_kv = $type_e :identifier :equal $e -> Output( type=$0, name=$1, expression=$3 )",
    ],
    112: [
        "$_gen20 = list($meta_kv, :comma)",
    ],
    113: [
        "$_gen7 = list($task_sections)",
    ],
    114: [
        "$object_kv = :identifier :colon $e -> ObjectKV( key=$0, value=$2 )",
    ],
    115: [
        "$_gen18 = list($input_kv, :comma)",
    ],
    116: [
        "$meta = :meta $meta_map -> Meta( map=$1 )",
    ],
    117: [
        "$type_e = :type <=> :lsquare $_gen21 :rsquare -> Type( name=$0, subtype=$2 )",
        "$type_e = :type <=> :qmark -> OptionalType( innerType=$0 )",
        "$type_e = :type <=> :plus -> NonEmptyType( innerType=$0 )",
        "$type_e = :type",
        "$type_e = :identifier",
    ],
    118: [
        "$_gen6 = list($import_alias)",
    ],
    119: [
        "$map_kv = $e :colon $e -> MapLiteralKv( key=$0, value=$2 )",
    ],
    120: [
        "$wf_body_element = $call",
        "$wf_body_element = $declaration",
        "$wf_body_element = $if_stmt",
        "$wf_body_element = $scatter",
        "$wf_body_element = $inputs",
        "$wf_body_element = $outputs",
        "$wf_body_element = $wf_parameter_meta",
        "$wf_body_element = $wf_meta",
    ],
    121: [
        "$setter = :equal $e -> $1",
    ],
    122: [
        "$declaration = $type_e :identifier $setter -> Declaration( type=$0, name=$1, expression=$2 )",
    ],
    123: [
        "$_gen8 = list($command_part)",
    ],
    124: [
        "$workflow = :workflow :identifier :lbrace $_gen15 :rbrace -> Workflow( name=$1, body=$3 )",
    ],
    125: [
        "$call = :call :fqn $_gen16 $_gen17 -> Call( task=$1, alias=$2, body=$3 )",
    ],
    126: [
        "$alias = :as :identifier -> $1",
    ],
    127: [
        "$input_kv = :identifier :equal $e -> ObjectKV( key=$0, value=$2 )",
    ],
    128: [
        "$_gen16 = $alias",
        "$_gen16 = :_empty",
    ],
    129: [
        "$_gen22 = list($e, :comma)",
    ],
    130: [
        "$_gen17 = $call_body",
        "$_gen17 = :_empty",
    ],
    131: [
        "$meta_kv = :identifier :colon $meta_value -> MetaKvPair( key=$0, value=$2 )",
    ],
    132: [
        "$call_body = :lbrace :input :colon $_gen18 :rbrace -> CallBody( inputs=$3 )",
    ],
    133: [
        "$command = :raw_command :raw_cmd_start $_gen8 :raw_cmd_end -> RawCommand( parts=$2 )",
    ],
    134: [
        "$input_declaration = $type_e :identifier $_gen13 -> InputDeclaration( type=$0, name=$1, expression=$2 )",
    ],
    135: [
        "$version = :version :version_name -> VersionDeclaration( v=$1 )",
    ],
}
rules = {
    0: "$_gen0 = list($import)",
    1: "$_gen1 = list($file_body_element)",
    2: "$document = $version $_gen0 $_gen1 -> Draft3File( version=$0, imports=$1, body=$2 )",
    3: "$file_body_element = $workflow",
    4: "$file_body_element = $task",
    5: "$file_body_element = $struct",
    6: "$version = :version :version_name -> VersionDeclaration( v=$1 )",
    7: "$_gen2 = list($struct_declaration)",
    8: "$struct = :struct :identifier :lbrace $_gen2 :rbrace -> Struct( name=$1, entries=$3 )",
    9: "$struct_declaration = $type_e :identifier -> StructEntry( type=$0, name=$1 )",
    10: "$_gen3 = list($static_string_piece)",
    11: "$static_string = :quote $_gen3 :quote -> StaticString( value=$1 )",
    12: "$_gen4 = list($string_piece)",
    13: "$string_literal = :quote $_gen4 :quote -> StringLiteral( pieces=$1 )",
    14: "$static_string_piece = :string",
    15: "$static_string_piece = :escape",
    16: "$string_piece = $static_string_piece",
    17: "$string_piece = $expression_placeholder",
    18: "$_gen5 = $import_namespace",
    19: "$_gen5 = :_empty",
    20: "$_gen6 = list($import_alias)",
    21: "$import = :import $static_string $_gen5 $_gen6 -> Import( uri=$1, namespace=$2, aliases=$3 )",
    22: "$import_namespace = :as :identifier -> $1",
    23: "$import_alias = :alias :identifier :as :identifier -> ImportAlias( old_name=$1, new_name=$3 )",
    24: "$_gen7 = list($task_sections)",
    25: "$task = :task :identifier :lbrace $_gen7 :rbrace -> Task( name=$1, sections=$3 )",
    26: "$task_sections = $command",
    27: "$task_sections = $inputs",
    28: "$task_sections = $outputs",
    29: "$task_sections = $runtime",
    30: "$task_sections = $parameter_meta",
    31: "$task_sections = $meta",
    32: "$task_sections = $declaration",
    33: "$_gen8 = list($command_part)",
    34: "$command = :raw_command :raw_cmd_start $_gen8 :raw_cmd_end -> RawCommand( parts=$2 )",
    35: "$command_part = :cmd_part",
    36: "$command_part = $expression_placeholder",
    37: "$_gen9 = list($expression_placeholder_kv)",
    38: "$expression_placeholder = :expression_placeholder_start $_gen9 $e :expression_placeholder_end -> ExpressionPlaceholder( attributes=$1, expr=$2 )",
    39: "$expression_placeholder_kv = :cmd_attr_hint :identifier :equal $e -> ExpressionPlaceholderAttr( key=$1, value=$3 )",
    40: "$_gen10 = list($input_declaration)",
    41: "$inputs = :input :lbrace $_gen10 :rbrace -> Inputs( inputs=$2 )",
    42: "$runtime = :runtime $rt_map -> Runtime( map=$1 )",
    43: "$_gen11 = list($kv)",
    44: "$rt_map = :lbrace $_gen11 :rbrace -> $1",
    45: "$kv = :identifier :colon $e -> RuntimeAttribute( key=$0, value=$2 )",
    46: "$meta = :meta $meta_map -> Meta( map=$1 )",
    47: "$parameter_meta = :parameter_meta $meta_map -> ParameterMeta( map=$1 )",
    48: "$_gen12 = list($meta_kv)",
    49: "$meta_map = :lbrace $_gen12 :rbrace -> $1",
    50: "$meta_kv = :identifier :colon $meta_value -> MetaKvPair( key=$0, value=$2 )",
    51: "$_gen13 = $setter",
    52: "$_gen13 = :_empty",
    53: "$input_declaration = $type_e :identifier $_gen13 -> InputDeclaration( type=$0, name=$1, expression=$2 )",
    54: "$declaration = $type_e :identifier $setter -> Declaration( type=$0, name=$1, expression=$2 )",
    55: "$setter = :equal $e -> $1",
    56: "$map_kv = $e :colon $e -> MapLiteralKv( key=$0, value=$2 )",
    57: "$_gen14 = list($output_kv)",
    58: "$outputs = :output :lbrace $_gen14 :rbrace -> Outputs( outputs=$2 )",
    59: "$output_kv = $type_e :identifier :equal $e -> Output( type=$0, name=$1, expression=$3 )",
    60: "$_gen15 = list($wf_body_element)",
    61: "$workflow = :workflow :identifier :lbrace $_gen15 :rbrace -> Workflow( name=$1, body=$3 )",
    62: "$wf_body_element = $call",
    63: "$wf_body_element = $declaration",
    64: "$wf_body_element = $if_stmt",
    65: "$wf_body_element = $scatter",
    66: "$wf_body_element = $inputs",
    67: "$wf_body_element = $outputs",
    68: "$wf_body_element = $wf_parameter_meta",
    69: "$wf_body_element = $wf_meta",
    70: "$_gen16 = $alias",
    71: "$_gen16 = :_empty",
    72: "$_gen17 = $call_body",
    73: "$_gen17 = :_empty",
    74: "$call = :call :fqn $_gen16 $_gen17 -> Call( task=$1, alias=$2, body=$3 )",
    75: "$_gen18 = list($input_kv, :comma)",
    76: "$call_body = :lbrace :input :colon $_gen18 :rbrace -> CallBody( inputs=$3 )",
    77: "$alias = :as :identifier -> $1",
    78: "$wf_parameter_meta = :parameter_meta $meta_map -> ParameterMeta( map=$1 )",
    79: "$wf_meta = :meta $meta_map -> Meta( map=$1 )",
    80: "$if_stmt = :if :lparen $e :rparen :lbrace $_gen15 :rbrace -> If( expression=$2, body=$5 )",
    81: "$scatter = :scatter :lparen :identifier :in $e :rparen :lbrace $_gen15 :rbrace -> Scatter( item=$2, collection=$4, body=$7 )",
    82: "$object_kv = :identifier :colon $e -> ObjectKV( key=$0, value=$2 )",
    83: "$input_kv = :identifier :equal $e -> ObjectKV( key=$0, value=$2 )",
    84: "$meta_value = $static_string",
    85: "$meta_value = :boolean",
    86: "$meta_value = :integer",
    87: "$meta_value = :float",
    88: "$meta_value = :null",
    89: "$_gen19 = list($meta_value, :comma)",
    90: "$meta_value = :lsquare $_gen19 :rsquare -> MetaArray( values=$1 )",
    91: "$_gen20 = list($meta_kv, :comma)",
    92: "$meta_value = :lbrace $_gen20 :rbrace -> MetaObject( map=$1 )",
    93: "$_gen21 = list($type_e, :comma)",
    94: "$type_e = :type <=> :lsquare $_gen21 :rsquare -> Type( name=$0, subtype=$2 )",
    95: "$type_e = :type <=> :qmark -> OptionalType( innerType=$0 )",
    96: "$type_e = :type <=> :plus -> NonEmptyType( innerType=$0 )",
    97: "$type_e = :type",
    98: "$type_e = :identifier",
    99: "$e = $e :double_pipe $e -> LogicalOr( lhs=$0, rhs=$2 )",
    100: "$e = $e :double_ampersand $e -> LogicalAnd( lhs=$0, rhs=$2 )",
    101: "$e = $e :double_equal $e -> Equals( lhs=$0, rhs=$2 )",
    102: "$e = $e :not_equal $e -> NotEquals( lhs=$0, rhs=$2 )",
    103: "$e = $e :lt $e -> LessThan( lhs=$0, rhs=$2 )",
    104: "$e = $e :lteq $e -> LessThanOrEqual( lhs=$0, rhs=$2 )",
    105: "$e = $e :gt $e -> GreaterThan( lhs=$0, rhs=$2 )",
    106: "$e = $e :gteq $e -> GreaterThanOrEqual( lhs=$0, rhs=$2 )",
    107: "$e = $e :plus $e -> Add( lhs=$0, rhs=$2 )",
    108: "$e = $e :dash $e -> Subtract( lhs=$0, rhs=$2 )",
    109: "$e = $e :asterisk $e -> Multiply( lhs=$0, rhs=$2 )",
    110: "$e = $e :slash $e -> Divide( lhs=$0, rhs=$2 )",
    111: "$e = $e :percent $e -> Remainder( lhs=$0, rhs=$2 )",
    112: "$e = :not $e -> LogicalNot( expression=$1 )",
    113: "$e = :plus $e -> UnaryPlus( expression=$1 )",
    114: "$e = :dash $e -> UnaryNegation( expression=$1 )",
    115: "$_gen22 = list($e, :comma)",
    116: "$e = :identifier <=> :lparen $_gen22 :rparen -> FunctionCall( name=$0, params=$2 )",
    117: "$e = $e <=> :lsquare $e :rsquare -> ArrayOrMapLookup( lhs=$0, rhs=$2 )",
    118: "$e = $e <=> :dot :identifier -> MemberAccess( value=$0, member=$2 )",
    119: "$_gen23 = list($object_kv, :comma)",
    120: "$e = :object :lbrace $_gen23 :rbrace -> ObjectLiteral( map=$2 )",
    121: "$e = :lsquare $_gen22 :rsquare -> ArrayLiteral( values=$1 )",
    122: "$_gen24 = list($map_kv, :comma)",
    123: "$e = :lbrace $_gen24 :rbrace -> MapLiteral( map=$1 )",
    124: "$e = :lparen $_gen22 :rparen -> TupleLiteral( values=$1 )",
    125: "$e = :if $e :then $e :else $e -> TernaryIf( cond=$1, iftrue=$3, iffalse=$5 )",
    126: "$e = $string_literal",
    127: "$e = :identifier",
    128: "$e = :boolean",
    129: "$e = :integer",
    130: "$e = :float",
}
def is_terminal(id): return isinstance(id, int) and 0 <= id <= 64
def parse(tokens, errors=None, start=None):
    if errors is None:
        errors = DefaultSyntaxErrorHandler()
    if isinstance(tokens, str):
        tokens = lex(tokens, 'string', errors)
    ctx = ParserContext(tokens, errors)
    tree = parse_document(ctx)
    if tokens.current() != None:
        raise ctx.errors.excess_tokens()
    return tree
def expect(ctx, terminal_id):
    current = ctx.tokens.current()
    if not current:
        raise ctx.errors.no_more_tokens(ctx.nonterminal, terminals[terminal_id], ctx.tokens.last())
    if current.id != terminal_id:
        raise ctx.errors.unexpected_symbol(ctx.nonterminal, current, [terminals[terminal_id]], ctx.rule)
    next = ctx.tokens.advance()
    if next and not is_terminal(next.id):
        raise ctx.errors.invalid_terminal(ctx.nonterminal, next)
    return current
# START definitions for expression parser: e
infix_binding_power_e = {
    61: 4000, # $e = $e :double_pipe $e -> LogicalOr( lhs=$0, rhs=$2 )
    56: 5000, # $e = $e :double_ampersand $e -> LogicalAnd( lhs=$0, rhs=$2 )
    34: 6000, # $e = $e :double_equal $e -> Equals( lhs=$0, rhs=$2 )
    46: 6000, # $e = $e :not_equal $e -> NotEquals( lhs=$0, rhs=$2 )
    32: 7000, # $e = $e :lt $e -> LessThan( lhs=$0, rhs=$2 )
    55: 7000, # $e = $e :lteq $e -> LessThanOrEqual( lhs=$0, rhs=$2 )
    4: 7000, # $e = $e :gt $e -> GreaterThan( lhs=$0, rhs=$2 )
    1: 7000, # $e = $e :gteq $e -> GreaterThanOrEqual( lhs=$0, rhs=$2 )
    30: 8000, # $e = $e :plus $e -> Add( lhs=$0, rhs=$2 )
    58: 8000, # $e = $e :dash $e -> Subtract( lhs=$0, rhs=$2 )
    42: 9000, # $e = $e :asterisk $e -> Multiply( lhs=$0, rhs=$2 )
    15: 9000, # $e = $e :slash $e -> Divide( lhs=$0, rhs=$2 )
    11: 9000, # $e = $e :percent $e -> Remainder( lhs=$0, rhs=$2 )
    8: 11000, # $e = :identifier <=> :lparen list($e, :comma) :rparen -> FunctionCall( name=$0, params=$2 )
    47: 12000, # $e = $e <=> :lsquare $e :rsquare -> ArrayOrMapLookup( lhs=$0, rhs=$2 )
    0: 13000, # $e = $e <=> :dot :identifier -> MemberAccess( value=$0, member=$2 )
}
prefix_binding_power_e = {
    44: 10000, # $e = :not $e -> LogicalNot( expression=$1 )
    30: 10000, # $e = :plus $e -> UnaryPlus( expression=$1 )
    58: 10000, # $e = :dash $e -> UnaryNegation( expression=$1 )
}
def get_infix_binding_power_e(terminal_id):
    try:
        return infix_binding_power_e[terminal_id]
    except:
        return 0
def get_prefix_binding_power_e(terminal_id):
    try:
        return prefix_binding_power_e[terminal_id]
    except:
        return 0
def parse_e(ctx):
    return parse_e_internal(ctx, rbp=0)
def parse_e_internal(ctx, rbp=0):
    left = nud_e(ctx)
    if isinstance(left, ParseTree):
        left.isExpr = True
        left.isNud = True
    while ctx.tokens.current() and rbp < get_infix_binding_power_e(ctx.tokens.current().id):
        left = led_e(left, ctx)
    if left:
        left.isExpr = True
    return left
def nud_e(ctx):
    tree = ParseTree(NonTerminal(89, 'e'))
    current = ctx.tokens.current()
    ctx.nonterminal = "e"
    if not current:
        return tree
    elif current.id in rule_first[112]:
        # rule first == not
        # e first == object, e, lparen, float, quote, dash, if, integer, not, identifier, lbrace, boolean, lsquare, plus
        # $e = :not $e -> LogicalNot( expression=$1 )
        ctx.rule = rules[112]
        ast_parameters = OrderedDict([
            ('expression', 1),
        ])
        tree.astTransform = AstTransformNodeCreator('LogicalNot', ast_parameters)
        tree.nudMorphemeCount = 2
        tree.add(expect(ctx, 44))
        tree.add(parse_e_internal(ctx, get_prefix_binding_power_e(44)))
        tree.isPrefix = True
    elif current.id in rule_first[113]:
        # rule first == plus
        # e first == object, e, lparen, float, quote, dash, if, integer, not, identifier, lbrace, boolean, lsquare, plus
        # $e = :plus $e -> UnaryPlus( expression=$1 )
        ctx.rule = rules[113]
        ast_parameters = OrderedDict([
            ('expression', 1),
        ])
        tree.astTransform = AstTransformNodeCreator('UnaryPlus', ast_parameters)
        tree.nudMorphemeCount = 2
        tree.add(expect(ctx, 30))
        tree.add(parse_e_internal(ctx, get_prefix_binding_power_e(30)))
        tree.isPrefix = True
    elif current.id in rule_first[114]:
        # rule first == dash
        # e first == object, e, lparen, float, quote, dash, if, integer, not, identifier, lbrace, boolean, lsquare, plus
        # $e = :dash $e -> UnaryNegation( expression=$1 )
        ctx.rule = rules[114]
        ast_parameters = OrderedDict([
            ('expression', 1),
        ])
        tree.astTransform = AstTransformNodeCreator('UnaryNegation', ast_parameters)
        tree.nudMorphemeCount = 2
        tree.add(expect(ctx, 58))
        tree.add(parse_e_internal(ctx, get_prefix_binding_power_e(58)))
        tree.isPrefix = True
    elif current.id in rule_first[116]:
        # rule first == identifier
        # e first == object, e, lparen, float, quote, dash, if, integer, not, identifier, lbrace, boolean, lsquare, plus
        # $e = :identifier <=> :lparen $_gen22 :rparen -> FunctionCall( name=$0, params=$2 )
        ctx.rule = rules[116]
        tree.astTransform = AstTransformSubstitution(0)
        tree.nudMorphemeCount = 1
        tree.add(expect(ctx, 12))
    elif current.id in rule_first[120]:
        # rule first == object
        # e first == object, e, lparen, float, quote, dash, if, integer, not, identifier, lbrace, boolean, lsquare, plus
        # $e = :object :lbrace $_gen23 :rbrace -> ObjectLiteral( map=$2 )
        ctx.rule = rules[120]
        ast_parameters = OrderedDict([
            ('map', 2),
        ])
        tree.astTransform = AstTransformNodeCreator('ObjectLiteral', ast_parameters)
        tree.nudMorphemeCount = 4
        tree.add(expect(ctx, 3))
        tree.add(expect(ctx, 26))
        tree.add(parse__gen23(ctx))
        tree.add(expect(ctx, 64))
    elif current.id in rule_first[121]:
        # rule first == lsquare
        # e first == object, e, lparen, float, quote, dash, if, integer, not, identifier, lbrace, boolean, lsquare, plus
        # $e = :lsquare $_gen22 :rsquare -> ArrayLiteral( values=$1 )
        ctx.rule = rules[121]
        ast_parameters = OrderedDict([
            ('values', 1),
        ])
        tree.astTransform = AstTransformNodeCreator('ArrayLiteral', ast_parameters)
        tree.nudMorphemeCount = 3
        tree.add(expect(ctx, 47))
        tree.add(parse__gen22(ctx))
        tree.add(expect(ctx, 39))
    elif current.id in rule_first[123]:
        # rule first == lbrace
        # e first == object, e, lparen, float, quote, dash, if, integer, not, identifier, lbrace, boolean, lsquare, plus
        # $e = :lbrace $_gen24 :rbrace -> MapLiteral( map=$1 )
        ctx.rule = rules[123]
        ast_parameters = OrderedDict([
            ('map', 1),
        ])
        tree.astTransform = AstTransformNodeCreator('MapLiteral', ast_parameters)
        tree.nudMorphemeCount = 3
        tree.add(expect(ctx, 26))
        tree.add(parse__gen24(ctx))
        tree.add(expect(ctx, 64))
    elif current.id in rule_first[124]:
        # rule first == lparen
        # e first == object, e, lparen, float, quote, dash, if, integer, not, identifier, lbrace, boolean, lsquare, plus
        # $e = :lparen $_gen22 :rparen -> TupleLiteral( values=$1 )
        ctx.rule = rules[124]
        ast_parameters = OrderedDict([
            ('values', 1),
        ])
        tree.astTransform = AstTransformNodeCreator('TupleLiteral', ast_parameters)
        tree.nudMorphemeCount = 3
        tree.add(expect(ctx, 8))
        tree.add(parse__gen22(ctx))
        tree.add(expect(ctx, 53))
    elif current.id in rule_first[125]:
        # rule first == if
        # e first == object, e, lparen, float, quote, dash, if, integer, not, identifier, lbrace, boolean, lsquare, plus
        # $e = :if $e :then $e :else $e -> TernaryIf( cond=$1, iftrue=$3, iffalse=$5 )
        ctx.rule = rules[125]
        ast_parameters = OrderedDict([
            ('cond', 1),
            ('iftrue', 3),
            ('iffalse', 5),
        ])
        tree.astTransform = AstTransformNodeCreator('TernaryIf', ast_parameters)
        tree.nudMorphemeCount = 6
        tree.add(expect(ctx, 57))
        tree.add(parse_e(ctx))
        tree.add(expect(ctx, 35))
        tree.add(parse_e(ctx))
        tree.add(expect(ctx, 29))
        tree.add(parse_e(ctx))
    elif current.id in rule_first[126]:
        # rule first == quote
        # e first == object, e, lparen, float, quote, dash, if, integer, not, identifier, lbrace, boolean, lsquare, plus
        # $e = $string_literal
        ctx.rule = rules[126]
        tree.astTransform = AstTransformSubstitution(0)
        tree.nudMorphemeCount = 1
        tree.add(parse_string_literal(ctx))
    elif current.id in rule_first[127]:
        # rule first == identifier
        # e first == object, e, lparen, float, quote, dash, if, integer, not, identifier, lbrace, boolean, lsquare, plus
        # $e = :identifier
        ctx.rule = rules[127]
        tree.astTransform = AstTransformSubstitution(0)
        tree.nudMorphemeCount = 1
        tree.add(expect(ctx, 12))
    elif current.id in rule_first[128]:
        # rule first == boolean
        # e first == object, e, lparen, float, quote, dash, if, integer, not, identifier, lbrace, boolean, lsquare, plus
        # $e = :boolean
        ctx.rule = rules[128]
        tree.astTransform = AstTransformSubstitution(0)
        tree.nudMorphemeCount = 1
        tree.add(expect(ctx, 45))
    elif current.id in rule_first[129]:
        # rule first == integer
        # e first == object, e, lparen, float, quote, dash, if, integer, not, identifier, lbrace, boolean, lsquare, plus
        # $e = :integer
        ctx.rule = rules[129]
        tree.astTransform = AstTransformSubstitution(0)
        tree.nudMorphemeCount = 1
        tree.add(expect(ctx, 22))
    elif current.id in rule_first[130]:
        # rule first == float
        # e first == object, e, lparen, float, quote, dash, if, integer, not, identifier, lbrace, boolean, lsquare, plus
        # $e = :float
        ctx.rule = rules[130]
        tree.astTransform = AstTransformSubstitution(0)
        tree.nudMorphemeCount = 1
        tree.add(expect(ctx, 16))
    return tree
def led_e(left, ctx):
    tree = ParseTree(NonTerminal(89, 'e'))
    current = ctx.tokens.current()
    ctx.nonterminal = "e"
    if current.id == 61: # :double_pipe
        # $e = $e :double_pipe $e -> LogicalOr( lhs=$0, rhs=$2 )
        ctx.rule = rules[99]
        ast_parameters = OrderedDict([
            ('lhs', 0),
            ('rhs', 2),
        ])
        tree.astTransform = AstTransformNodeCreator('LogicalOr', ast_parameters)
        tree.isExprNud = True
        tree.add(left)
        tree.add(expect(ctx, 61)) # :double_pipe
        modifier = 0
        tree.isInfix = True
        tree.add(parse_e_internal(ctx, get_infix_binding_power_e(61) - modifier))
    if current.id == 56: # :double_ampersand
        # $e = $e :double_ampersand $e -> LogicalAnd( lhs=$0, rhs=$2 )
        ctx.rule = rules[100]
        ast_parameters = OrderedDict([
            ('lhs', 0),
            ('rhs', 2),
        ])
        tree.astTransform = AstTransformNodeCreator('LogicalAnd', ast_parameters)
        tree.isExprNud = True
        tree.add(left)
        tree.add(expect(ctx, 56)) # :double_ampersand
        modifier = 0
        tree.isInfix = True
        tree.add(parse_e_internal(ctx, get_infix_binding_power_e(56) - modifier))
    if current.id == 34: # :double_equal
        # $e = $e :double_equal $e -> Equals( lhs=$0, rhs=$2 )
        ctx.rule = rules[101]
        ast_parameters = OrderedDict([
            ('lhs', 0),
            ('rhs', 2),
        ])
        tree.astTransform = AstTransformNodeCreator('Equals', ast_parameters)
        tree.isExprNud = True
        tree.add(left)
        tree.add(expect(ctx, 34)) # :double_equal
        modifier = 0
        tree.isInfix = True
        tree.add(parse_e_internal(ctx, get_infix_binding_power_e(34) - modifier))
    if current.id == 46: # :not_equal
        # $e = $e :not_equal $e -> NotEquals( lhs=$0, rhs=$2 )
        ctx.rule = rules[102]
        ast_parameters = OrderedDict([
            ('lhs', 0),
            ('rhs', 2),
        ])
        tree.astTransform = AstTransformNodeCreator('NotEquals', ast_parameters)
        tree.isExprNud = True
        tree.add(left)
        tree.add(expect(ctx, 46)) # :not_equal
        modifier = 0
        tree.isInfix = True
        tree.add(parse_e_internal(ctx, get_infix_binding_power_e(46) - modifier))
    if current.id == 32: # :lt
        # $e = $e :lt $e -> LessThan( lhs=$0, rhs=$2 )
        ctx.rule = rules[103]
        ast_parameters = OrderedDict([
            ('lhs', 0),
            ('rhs', 2),
        ])
        tree.astTransform = AstTransformNodeCreator('LessThan', ast_parameters)
        tree.isExprNud = True
        tree.add(left)
        tree.add(expect(ctx, 32)) # :lt
        modifier = 0
        tree.isInfix = True
        tree.add(parse_e_internal(ctx, get_infix_binding_power_e(32) - modifier))
    if current.id == 55: # :lteq
        # $e = $e :lteq $e -> LessThanOrEqual( lhs=$0, rhs=$2 )
        ctx.rule = rules[104]
        ast_parameters = OrderedDict([
            ('lhs', 0),
            ('rhs', 2),
        ])
        tree.astTransform = AstTransformNodeCreator('LessThanOrEqual', ast_parameters)
        tree.isExprNud = True
        tree.add(left)
        tree.add(expect(ctx, 55)) # :lteq
        modifier = 0
        tree.isInfix = True
        tree.add(parse_e_internal(ctx, get_infix_binding_power_e(55) - modifier))
    if current.id == 4: # :gt
        # $e = $e :gt $e -> GreaterThan( lhs=$0, rhs=$2 )
        ctx.rule = rules[105]
        ast_parameters = OrderedDict([
            ('lhs', 0),
            ('rhs', 2),
        ])
        tree.astTransform = AstTransformNodeCreator('GreaterThan', ast_parameters)
        tree.isExprNud = True
        tree.add(left)
        tree.add(expect(ctx, 4)) # :gt
        modifier = 0
        tree.isInfix = True
        tree.add(parse_e_internal(ctx, get_infix_binding_power_e(4) - modifier))
    if current.id == 1: # :gteq
        # $e = $e :gteq $e -> GreaterThanOrEqual( lhs=$0, rhs=$2 )
        ctx.rule = rules[106]
        ast_parameters = OrderedDict([
            ('lhs', 0),
            ('rhs', 2),
        ])
        tree.astTransform = AstTransformNodeCreator('GreaterThanOrEqual', ast_parameters)
        tree.isExprNud = True
        tree.add(left)
        tree.add(expect(ctx, 1)) # :gteq
        modifier = 0
        tree.isInfix = True
        tree.add(parse_e_internal(ctx, get_infix_binding_power_e(1) - modifier))
    if current.id == 30: # :plus
        # $e = $e :plus $e -> Add( lhs=$0, rhs=$2 )
        ctx.rule = rules[107]
        ast_parameters = OrderedDict([
            ('lhs', 0),
            ('rhs', 2),
        ])
        tree.astTransform = AstTransformNodeCreator('Add', ast_parameters)
        tree.isExprNud = True
        tree.add(left)
        tree.add(expect(ctx, 30)) # :plus
        modifier = 0
        tree.isInfix = True
        tree.add(parse_e_internal(ctx, get_infix_binding_power_e(30) - modifier))
    if current.id == 58: # :dash
        # $e = $e :dash $e -> Subtract( lhs=$0, rhs=$2 )
        ctx.rule = rules[108]
        ast_parameters = OrderedDict([
            ('lhs', 0),
            ('rhs', 2),
        ])
        tree.astTransform = AstTransformNodeCreator('Subtract', ast_parameters)
        tree.isExprNud = True
        tree.add(left)
        tree.add(expect(ctx, 58)) # :dash
        modifier = 0
        tree.isInfix = True
        tree.add(parse_e_internal(ctx, get_infix_binding_power_e(58) - modifier))
    if current.id == 42: # :asterisk
        # $e = $e :asterisk $e -> Multiply( lhs=$0, rhs=$2 )
        ctx.rule = rules[109]
        ast_parameters = OrderedDict([
            ('lhs', 0),
            ('rhs', 2),
        ])
        tree.astTransform = AstTransformNodeCreator('Multiply', ast_parameters)
        tree.isExprNud = True
        tree.add(left)
        tree.add(expect(ctx, 42)) # :asterisk
        modifier = 0
        tree.isInfix = True
        tree.add(parse_e_internal(ctx, get_infix_binding_power_e(42) - modifier))
    if current.id == 15: # :slash
        # $e = $e :slash $e -> Divide( lhs=$0, rhs=$2 )
        ctx.rule = rules[110]
        ast_parameters = OrderedDict([
            ('lhs', 0),
            ('rhs', 2),
        ])
        tree.astTransform = AstTransformNodeCreator('Divide', ast_parameters)
        tree.isExprNud = True
        tree.add(left)
        tree.add(expect(ctx, 15)) # :slash
        modifier = 0
        tree.isInfix = True
        tree.add(parse_e_internal(ctx, get_infix_binding_power_e(15) - modifier))
    if current.id == 11: # :percent
        # $e = $e :percent $e -> Remainder( lhs=$0, rhs=$2 )
        ctx.rule = rules[111]
        ast_parameters = OrderedDict([
            ('lhs', 0),
            ('rhs', 2),
        ])
        tree.astTransform = AstTransformNodeCreator('Remainder', ast_parameters)
        tree.isExprNud = True
        tree.add(left)
        tree.add(expect(ctx, 11)) # :percent
        modifier = 0
        tree.isInfix = True
        tree.add(parse_e_internal(ctx, get_infix_binding_power_e(11) - modifier))
    if current.id == 8: # :lparen
        # $e = :identifier <=> :lparen $_gen22 :rparen -> FunctionCall( name=$0, params=$2 )
        ctx.rule = rules[116]
        ast_parameters = OrderedDict([
            ('name', 0),
            ('params', 2),
        ])
        tree.astTransform = AstTransformNodeCreator('FunctionCall', ast_parameters)
        tree.add(left)
        tree.add(expect(ctx, 8)) # :lparen
        tree.add(parse__gen22(ctx))
        tree.add(expect(ctx, 53)) # :rparen
    if current.id == 47: # :lsquare
        # $e = $e <=> :lsquare $e :rsquare -> ArrayOrMapLookup( lhs=$0, rhs=$2 )
        ctx.rule = rules[117]
        ast_parameters = OrderedDict([
            ('lhs', 0),
            ('rhs', 2),
        ])
        tree.astTransform = AstTransformNodeCreator('ArrayOrMapLookup', ast_parameters)
        tree.isExprNud = True
        tree.add(left)
        tree.add(expect(ctx, 47)) # :lsquare
        modifier = 0
        tree.add(parse_e_internal(ctx, get_infix_binding_power_e(47) - modifier))
        tree.add(expect(ctx, 39)) # :rsquare
    if current.id == 0: # :dot
        # $e = $e <=> :dot :identifier -> MemberAccess( value=$0, member=$2 )
        ctx.rule = rules[118]
        ast_parameters = OrderedDict([
            ('value', 0),
            ('member', 2),
        ])
        tree.astTransform = AstTransformNodeCreator('MemberAccess', ast_parameters)
        tree.isExprNud = True
        tree.add(left)
        tree.add(expect(ctx, 0)) # :dot
        tree.add(expect(ctx, 12)) # :identifier
    return tree
# END definitions for expression parser: e
# START definitions for expression parser: meta_value
infix_binding_power_meta_value = {
}
prefix_binding_power_meta_value = {
}
def get_infix_binding_power_meta_value(terminal_id):
    try:
        return infix_binding_power_meta_value[terminal_id]
    except:
        return 0
def get_prefix_binding_power_meta_value(terminal_id):
    try:
        return prefix_binding_power_meta_value[terminal_id]
    except:
        return 0
def parse_meta_value(ctx):
    return parse_meta_value_internal(ctx, rbp=0)
def parse_meta_value_internal(ctx, rbp=0):
    left = nud_meta_value(ctx)
    if isinstance(left, ParseTree):
        left.isExpr = True
        left.isNud = True
    while ctx.tokens.current() and rbp < get_infix_binding_power_meta_value(ctx.tokens.current().id):
        left = led_meta_value(left, ctx)
    if left:
        left.isExpr = True
    return left
def nud_meta_value(ctx):
    tree = ParseTree(NonTerminal(67, 'meta_value'))
    current = ctx.tokens.current()
    ctx.nonterminal = "meta_value"
    if not current:
        return tree
    if current.id in rule_first[84]:
        # rule first == quote
        # e first == null, integer, lsquare, meta_value, lbrace, boolean, float, quote
        # $meta_value = $static_string
        ctx.rule = rules[84]
        tree.astTransform = AstTransformSubstitution(0)
        tree.nudMorphemeCount = 1
        tree.add(parse_static_string(ctx))
    elif current.id in rule_first[85]:
        # rule first == boolean
        # e first == null, integer, lsquare, meta_value, lbrace, boolean, float, quote
        # $meta_value = :boolean
        ctx.rule = rules[85]
        tree.astTransform = AstTransformSubstitution(0)
        tree.nudMorphemeCount = 1
        tree.add(expect(ctx, 45))
    elif current.id in rule_first[86]:
        # rule first == integer
        # e first == null, integer, lsquare, meta_value, lbrace, boolean, float, quote
        # $meta_value = :integer
        ctx.rule = rules[86]
        tree.astTransform = AstTransformSubstitution(0)
        tree.nudMorphemeCount = 1
        tree.add(expect(ctx, 22))
    elif current.id in rule_first[87]:
        # rule first == float
        # e first == null, integer, lsquare, meta_value, lbrace, boolean, float, quote
        # $meta_value = :float
        ctx.rule = rules[87]
        tree.astTransform = AstTransformSubstitution(0)
        tree.nudMorphemeCount = 1
        tree.add(expect(ctx, 16))
    elif current.id in rule_first[88]:
        # rule first == null
        # e first == null, integer, lsquare, meta_value, lbrace, boolean, float, quote
        # $meta_value = :null
        ctx.rule = rules[88]
        tree.astTransform = AstTransformSubstitution(0)
        tree.nudMorphemeCount = 1
        tree.add(expect(ctx, 49))
    elif current.id in rule_first[90]:
        # rule first == lsquare
        # e first == null, integer, lsquare, meta_value, lbrace, boolean, float, quote
        # $meta_value = :lsquare $_gen19 :rsquare -> MetaArray( values=$1 )
        ctx.rule = rules[90]
        ast_parameters = OrderedDict([
            ('values', 1),
        ])
        tree.astTransform = AstTransformNodeCreator('MetaArray', ast_parameters)
        tree.nudMorphemeCount = 3
        tree.add(expect(ctx, 47))
        tree.add(parse__gen19(ctx))
        tree.add(expect(ctx, 39))
    elif current.id in rule_first[92]:
        # rule first == lbrace
        # e first == null, integer, lsquare, meta_value, lbrace, boolean, float, quote
        # $meta_value = :lbrace $_gen20 :rbrace -> MetaObject( map=$1 )
        ctx.rule = rules[92]
        ast_parameters = OrderedDict([
            ('map', 1),
        ])
        tree.astTransform = AstTransformNodeCreator('MetaObject', ast_parameters)
        tree.nudMorphemeCount = 3
        tree.add(expect(ctx, 26))
        tree.add(parse__gen20(ctx))
        tree.add(expect(ctx, 64))
    return tree
def led_meta_value(left, ctx):
    tree = ParseTree(NonTerminal(67, 'meta_value'))
    current = ctx.tokens.current()
    ctx.nonterminal = "meta_value"
    return tree
# END definitions for expression parser: meta_value
# START definitions for expression parser: type_e
infix_binding_power_type_e = {
    47: 1000, # $type_e = :type <=> :lsquare list($type_e, :comma) :rsquare -> Type( name=$0, subtype=$2 )
    50: 2000, # $type_e = :type <=> :qmark -> OptionalType( innerType=$0 )
    30: 3000, # $type_e = :type <=> :plus -> NonEmptyType( innerType=$0 )
}
prefix_binding_power_type_e = {
}
def get_infix_binding_power_type_e(terminal_id):
    try:
        return infix_binding_power_type_e[terminal_id]
    except:
        return 0
def get_prefix_binding_power_type_e(terminal_id):
    try:
        return prefix_binding_power_type_e[terminal_id]
    except:
        return 0
def parse_type_e(ctx):
    return parse_type_e_internal(ctx, rbp=0)
def parse_type_e_internal(ctx, rbp=0):
    left = nud_type_e(ctx)
    if isinstance(left, ParseTree):
        left.isExpr = True
        left.isNud = True
    while ctx.tokens.current() and rbp < get_infix_binding_power_type_e(ctx.tokens.current().id):
        left = led_type_e(left, ctx)
    if left:
        left.isExpr = True
    return left
def nud_type_e(ctx):
    tree = ParseTree(NonTerminal(117, 'type_e'))
    current = ctx.tokens.current()
    ctx.nonterminal = "type_e"
    if not current:
        return tree
    if current.id in rule_first[94]:
        # rule first == type
        # e first == type, type_e, identifier
        # $type_e = :type <=> :lsquare $_gen21 :rsquare -> Type( name=$0, subtype=$2 )
        ctx.rule = rules[94]
        tree.astTransform = AstTransformSubstitution(0)
        tree.nudMorphemeCount = 1
        tree.add(expect(ctx, 10))
    elif current.id in rule_first[95]:
        # rule first == type
        # e first == type, type_e, identifier
        # $type_e = :type <=> :qmark -> OptionalType( innerType=$0 )
        ctx.rule = rules[95]
        tree.astTransform = AstTransformSubstitution(0)
        tree.nudMorphemeCount = 1
        tree.add(expect(ctx, 10))
    elif current.id in rule_first[96]:
        # rule first == type
        # e first == type, type_e, identifier
        # $type_e = :type <=> :plus -> NonEmptyType( innerType=$0 )
        ctx.rule = rules[96]
        tree.astTransform = AstTransformSubstitution(0)
        tree.nudMorphemeCount = 1
        tree.add(expect(ctx, 10))
    elif current.id in rule_first[97]:
        # rule first == type
        # e first == type, type_e, identifier
        # $type_e = :type
        ctx.rule = rules[97]
        tree.astTransform = AstTransformSubstitution(0)
        tree.nudMorphemeCount = 1
        tree.add(expect(ctx, 10))
    elif current.id in rule_first[98]:
        # rule first == identifier
        # e first == type, type_e, identifier
        # $type_e = :identifier
        ctx.rule = rules[98]
        tree.astTransform = AstTransformSubstitution(0)
        tree.nudMorphemeCount = 1
        tree.add(expect(ctx, 12))
    return tree
def led_type_e(left, ctx):
    tree = ParseTree(NonTerminal(117, 'type_e'))
    current = ctx.tokens.current()
    ctx.nonterminal = "type_e"
    if current.id == 47: # :lsquare
        # $type_e = :type <=> :lsquare $_gen21 :rsquare -> Type( name=$0, subtype=$2 )
        ctx.rule = rules[94]
        ast_parameters = OrderedDict([
            ('name', 0),
            ('subtype', 2),
        ])
        tree.astTransform = AstTransformNodeCreator('Type', ast_parameters)
        tree.add(left)
        tree.add(expect(ctx, 47)) # :lsquare
        tree.add(parse__gen21(ctx))
        tree.add(expect(ctx, 39)) # :rsquare
    if current.id == 50: # :qmark
        # $type_e = :type <=> :qmark -> OptionalType( innerType=$0 )
        ctx.rule = rules[95]
        ast_parameters = OrderedDict([
            ('innerType', 0),
        ])
        tree.astTransform = AstTransformNodeCreator('OptionalType', ast_parameters)
        tree.add(left)
        tree.add(expect(ctx, 50)) # :qmark
    if current.id == 30: # :plus
        # $type_e = :type <=> :plus -> NonEmptyType( innerType=$0 )
        ctx.rule = rules[96]
        ast_parameters = OrderedDict([
            ('innerType', 0),
        ])
        tree.astTransform = AstTransformNodeCreator('NonEmptyType', ast_parameters)
        tree.add(left)
        tree.add(expect(ctx, 30)) # :plus
    return tree
# END definitions for expression parser: type_e
def parse__gen0(ctx):
    tree = ParseTree(NonTerminal(98, '_gen0'))
    tree.list = True
    ctx.nonterminal = "_gen0"
    if ctx.tokens.current() is not None and \
       ctx.tokens.current().id not in nonterminal_first[98] and \
       ctx.tokens.current().id in nonterminal_follow[98]:
        return tree
    if ctx.tokens.current() is None:
        return tree
    minimum = 0
    while minimum > 0 or \
           (ctx.tokens.current() is not None and \
            ctx.tokens.current().id in nonterminal_first.get(98)):
        tree.add(parse_import(ctx))
        ctx.nonterminal = "_gen0" # Horrible -- because parse_* can reset this
        minimum = max(minimum - 1, 0)
    return tree
def parse__gen1(ctx):
    tree = ParseTree(NonTerminal(96, '_gen1'))
    tree.list = True
    ctx.nonterminal = "_gen1"
    if ctx.tokens.current() is not None and \
       ctx.tokens.current().id not in nonterminal_first[96] and \
       ctx.tokens.current().id in nonterminal_follow[96]:
        return tree
    if ctx.tokens.current() is None:
        return tree
    minimum = 0
    while minimum > 0 or \
           (ctx.tokens.current() is not None and \
            ctx.tokens.current().id in nonterminal_first.get(96)):
        tree.add(parse_file_body_element(ctx))
        ctx.nonterminal = "_gen1" # Horrible -- because parse_* can reset this
        minimum = max(minimum - 1, 0)
    return tree
def parse__gen10(ctx):
    tree = ParseTree(NonTerminal(104, '_gen10'))
    tree.list = True
    ctx.nonterminal = "_gen10"
    if ctx.tokens.current() is not None and \
       ctx.tokens.current().id not in nonterminal_first[104] and \
       ctx.tokens.current().id in nonterminal_follow[104]:
        return tree
    if ctx.tokens.current() is None:
        return tree
    minimum = 0
    while minimum > 0 or \
           (ctx.tokens.current() is not None and \
            ctx.tokens.current().id in nonterminal_first.get(104)):
        tree.add(parse_input_declaration(ctx))
        ctx.nonterminal = "_gen10" # Horrible -- because parse_* can reset this
        minimum = max(minimum - 1, 0)
    return tree
def parse__gen11(ctx):
    tree = ParseTree(NonTerminal(81, '_gen11'))
    tree.list = True
    ctx.nonterminal = "_gen11"
    if ctx.tokens.current() is not None and \
       ctx.tokens.current().id not in nonterminal_first[81] and \
       ctx.tokens.current().id in nonterminal_follow[81]:
        return tree
    if ctx.tokens.current() is None:
        return tree
    minimum = 0
    while minimum > 0 or \
           (ctx.tokens.current() is not None and \
            ctx.tokens.current().id in nonterminal_first.get(81)):
        tree.add(parse_kv(ctx))
        ctx.nonterminal = "_gen11" # Horrible -- because parse_* can reset this
        minimum = max(minimum - 1, 0)
    return tree
def parse__gen12(ctx):
    tree = ParseTree(NonTerminal(109, '_gen12'))
    tree.list = True
    ctx.nonterminal = "_gen12"
    if ctx.tokens.current() is not None and \
       ctx.tokens.current().id not in nonterminal_first[109] and \
       ctx.tokens.current().id in nonterminal_follow[109]:
        return tree
    if ctx.tokens.current() is None:
        return tree
    minimum = 0
    while minimum > 0 or \
           (ctx.tokens.current() is not None and \
            ctx.tokens.current().id in nonterminal_first.get(109)):
        tree.add(parse_meta_kv(ctx))
        ctx.nonterminal = "_gen12" # Horrible -- because parse_* can reset this
        minimum = max(minimum - 1, 0)
    return tree
def parse__gen14(ctx):
    tree = ParseTree(NonTerminal(65, '_gen14'))
    tree.list = True
    ctx.nonterminal = "_gen14"
    if ctx.tokens.current() is not None and \
       ctx.tokens.current().id not in nonterminal_first[65] and \
       ctx.tokens.current().id in nonterminal_follow[65]:
        return tree
    if ctx.tokens.current() is None:
        return tree
    minimum = 0
    while minimum > 0 or \
           (ctx.tokens.current() is not None and \
            ctx.tokens.current().id in nonterminal_first.get(65)):
        tree.add(parse_output_kv(ctx))
        ctx.nonterminal = "_gen14" # Horrible -- because parse_* can reset this
        minimum = max(minimum - 1, 0)
    return tree
def parse__gen15(ctx):
    tree = ParseTree(NonTerminal(87, '_gen15'))
    tree.list = True
    ctx.nonterminal = "_gen15"
    if ctx.tokens.current() is not None and \
       ctx.tokens.current().id not in nonterminal_first[87] and \
       ctx.tokens.current().id in nonterminal_follow[87]:
        return tree
    if ctx.tokens.current() is None:
        return tree
    minimum = 0
    while minimum > 0 or \
           (ctx.tokens.current() is not None and \
            ctx.tokens.current().id in nonterminal_first.get(87)):
        tree.add(parse_wf_body_element(ctx))
        ctx.nonterminal = "_gen15" # Horrible -- because parse_* can reset this
        minimum = max(minimum - 1, 0)
    return tree
def parse__gen18(ctx):
    tree = ParseTree(NonTerminal(115, '_gen18'))
    tree.list = True
    tree.list_separator_id = 60
    ctx.nonterminal = "_gen18"
    if ctx.tokens.current() is not None and \
       ctx.tokens.current().id not in nonterminal_first[115] and \
       ctx.tokens.current().id in nonterminal_follow[115]:
        return tree
    if ctx.tokens.current() is None:
        return tree
    minimum = 0
    while minimum > 0 or \
           (ctx.tokens.current() is not None and \
            ctx.tokens.current().id in nonterminal_first.get(115)):
        tree.add(parse_input_kv(ctx))
        ctx.nonterminal = "_gen18" # Horrible -- because parse_* can reset this
        if ctx.tokens.current() is not None and ctx.tokens.current().id == 60:
            tree.add(expect(ctx, 60));
        else:
          break
        minimum = max(minimum - 1, 0)
    return tree
def parse__gen19(ctx):
    tree = ParseTree(NonTerminal(77, '_gen19'))
    tree.list = True
    tree.list_separator_id = 60
    ctx.nonterminal = "_gen19"
    if ctx.tokens.current() is not None and \
       ctx.tokens.current().id not in nonterminal_first[77] and \
       ctx.tokens.current().id in nonterminal_follow[77]:
        return tree
    if ctx.tokens.current() is None:
        return tree
    minimum = 0
    while minimum > 0 or \
           (ctx.tokens.current() is not None and \
            ctx.tokens.current().id in nonterminal_first.get(77)):
        tree.add(parse_meta_value(ctx))
        ctx.nonterminal = "_gen19" # Horrible -- because parse_* can reset this
        if ctx.tokens.current() is not None and ctx.tokens.current().id == 60:
            tree.add(expect(ctx, 60));
        else:
          break
        minimum = max(minimum - 1, 0)
    return tree
def parse__gen2(ctx):
    tree = ParseTree(NonTerminal(84, '_gen2'))
    tree.list = True
    ctx.nonterminal = "_gen2"
    if ctx.tokens.current() is not None and \
       ctx.tokens.current().id not in nonterminal_first[84] and \
       ctx.tokens.current().id in nonterminal_follow[84]:
        return tree
    if ctx.tokens.current() is None:
        return tree
    minimum = 0
    while minimum > 0 or \
           (ctx.tokens.current() is not None and \
            ctx.tokens.current().id in nonterminal_first.get(84)):
        tree.add(parse_struct_declaration(ctx))
        ctx.nonterminal = "_gen2" # Horrible -- because parse_* can reset this
        minimum = max(minimum - 1, 0)
    return tree
def parse__gen20(ctx):
    tree = ParseTree(NonTerminal(112, '_gen20'))
    tree.list = True
    tree.list_separator_id = 60
    ctx.nonterminal = "_gen20"
    if ctx.tokens.current() is not None and \
       ctx.tokens.current().id not in nonterminal_first[112] and \
       ctx.tokens.current().id in nonterminal_follow[112]:
        return tree
    if ctx.tokens.current() is None:
        return tree
    minimum = 0
    while minimum > 0 or \
           (ctx.tokens.current() is not None and \
            ctx.tokens.current().id in nonterminal_first.get(112)):
        tree.add(parse_meta_kv(ctx))
        ctx.nonterminal = "_gen20" # Horrible -- because parse_* can reset this
        if ctx.tokens.current() is not None and ctx.tokens.current().id == 60:
            tree.add(expect(ctx, 60));
        else:
          break
        minimum = max(minimum - 1, 0)
    return tree
def parse__gen21(ctx):
    tree = ParseTree(NonTerminal(94, '_gen21'))
    tree.list = True
    tree.list_separator_id = 60
    ctx.nonterminal = "_gen21"
    if ctx.tokens.current() is not None and \
       ctx.tokens.current().id not in nonterminal_first[94] and \
       ctx.tokens.current().id in nonterminal_follow[94]:
        return tree
    if ctx.tokens.current() is None:
        return tree
    minimum = 0
    while minimum > 0 or \
           (ctx.tokens.current() is not None and \
            ctx.tokens.current().id in nonterminal_first.get(94)):
        tree.add(parse_type_e(ctx))
        ctx.nonterminal = "_gen21" # Horrible -- because parse_* can reset this
        if ctx.tokens.current() is not None and ctx.tokens.current().id == 60:
            tree.add(expect(ctx, 60));
        else:
          break
        minimum = max(minimum - 1, 0)
    return tree
def parse__gen22(ctx):
    tree = ParseTree(NonTerminal(129, '_gen22'))
    tree.list = True
    tree.list_separator_id = 60
    ctx.nonterminal = "_gen22"
    if ctx.tokens.current() is not None and \
       ctx.tokens.current().id not in nonterminal_first[129] and \
       ctx.tokens.current().id in nonterminal_follow[129]:
        return tree
    if ctx.tokens.current() is None:
        return tree
    minimum = 0
    while minimum > 0 or \
           (ctx.tokens.current() is not None and \
            ctx.tokens.current().id in nonterminal_first.get(129)):
        tree.add(parse_e(ctx))
        ctx.nonterminal = "_gen22" # Horrible -- because parse_* can reset this
        if ctx.tokens.current() is not None and ctx.tokens.current().id == 60:
            tree.add(expect(ctx, 60));
        else:
          break
        minimum = max(minimum - 1, 0)
    return tree
def parse__gen23(ctx):
    tree = ParseTree(NonTerminal(105, '_gen23'))
    tree.list = True
    tree.list_separator_id = 60
    ctx.nonterminal = "_gen23"
    if ctx.tokens.current() is not None and \
       ctx.tokens.current().id not in nonterminal_first[105] and \
       ctx.tokens.current().id in nonterminal_follow[105]:
        return tree
    if ctx.tokens.current() is None:
        return tree
    minimum = 0
    while minimum > 0 or \
           (ctx.tokens.current() is not None and \
            ctx.tokens.current().id in nonterminal_first.get(105)):
        tree.add(parse_object_kv(ctx))
        ctx.nonterminal = "_gen23" # Horrible -- because parse_* can reset this
        if ctx.tokens.current() is not None and ctx.tokens.current().id == 60:
            tree.add(expect(ctx, 60));
        else:
          break
        minimum = max(minimum - 1, 0)
    return tree
def parse__gen24(ctx):
    tree = ParseTree(NonTerminal(68, '_gen24'))
    tree.list = True
    tree.list_separator_id = 60
    ctx.nonterminal = "_gen24"
    if ctx.tokens.current() is not None and \
       ctx.tokens.current().id not in nonterminal_first[68] and \
       ctx.tokens.current().id in nonterminal_follow[68]:
        return tree
    if ctx.tokens.current() is None:
        return tree
    minimum = 0
    while minimum > 0 or \
           (ctx.tokens.current() is not None and \
            ctx.tokens.current().id in nonterminal_first.get(68)):
        tree.add(parse_map_kv(ctx))
        ctx.nonterminal = "_gen24" # Horrible -- because parse_* can reset this
        if ctx.tokens.current() is not None and ctx.tokens.current().id == 60:
            tree.add(expect(ctx, 60));
        else:
          break
        minimum = max(minimum - 1, 0)
    return tree
def parse__gen3(ctx):
    tree = ParseTree(NonTerminal(95, '_gen3'))
    tree.list = True
    ctx.nonterminal = "_gen3"
    if ctx.tokens.current() is not None and \
       ctx.tokens.current().id not in nonterminal_first[95] and \
       ctx.tokens.current().id in nonterminal_follow[95]:
        return tree
    if ctx.tokens.current() is None:
        return tree
    minimum = 0
    while minimum > 0 or \
           (ctx.tokens.current() is not None and \
            ctx.tokens.current().id in nonterminal_first.get(95)):
        tree.add(parse_static_string_piece(ctx))
        ctx.nonterminal = "_gen3" # Horrible -- because parse_* can reset this
        minimum = max(minimum - 1, 0)
    return tree
def parse__gen4(ctx):
    tree = ParseTree(NonTerminal(83, '_gen4'))
    tree.list = True
    ctx.nonterminal = "_gen4"
    if ctx.tokens.current() is not None and \
       ctx.tokens.current().id not in nonterminal_first[83] and \
       ctx.tokens.current().id in nonterminal_follow[83]:
        return tree
    if ctx.tokens.current() is None:
        return tree
    minimum = 0
    while minimum > 0 or \
           (ctx.tokens.current() is not None and \
            ctx.tokens.current().id in nonterminal_first.get(83)):
        tree.add(parse_string_piece(ctx))
        ctx.nonterminal = "_gen4" # Horrible -- because parse_* can reset this
        minimum = max(minimum - 1, 0)
    return tree
def parse__gen6(ctx):
    tree = ParseTree(NonTerminal(118, '_gen6'))
    tree.list = True
    ctx.nonterminal = "_gen6"
    if ctx.tokens.current() is not None and \
       ctx.tokens.current().id not in nonterminal_first[118] and \
       ctx.tokens.current().id in nonterminal_follow[118]:
        return tree
    if ctx.tokens.current() is None:
        return tree
    minimum = 0
    while minimum > 0 or \
           (ctx.tokens.current() is not None and \
            ctx.tokens.current().id in nonterminal_first.get(118)):
        tree.add(parse_import_alias(ctx))
        ctx.nonterminal = "_gen6" # Horrible -- because parse_* can reset this
        minimum = max(minimum - 1, 0)
    return tree
def parse__gen7(ctx):
    tree = ParseTree(NonTerminal(113, '_gen7'))
    tree.list = True
    ctx.nonterminal = "_gen7"
    if ctx.tokens.current() is not None and \
       ctx.tokens.current().id not in nonterminal_first[113] and \
       ctx.tokens.current().id in nonterminal_follow[113]:
        return tree
    if ctx.tokens.current() is None:
        return tree
    minimum = 0
    while minimum > 0 or \
           (ctx.tokens.current() is not None and \
            ctx.tokens.current().id in nonterminal_first.get(113)):
        tree.add(parse_task_sections(ctx))
        ctx.nonterminal = "_gen7" # Horrible -- because parse_* can reset this
        minimum = max(minimum - 1, 0)
    return tree
def parse__gen8(ctx):
    tree = ParseTree(NonTerminal(123, '_gen8'))
    tree.list = True
    ctx.nonterminal = "_gen8"
    if ctx.tokens.current() is not None and \
       ctx.tokens.current().id not in nonterminal_first[123] and \
       ctx.tokens.current().id in nonterminal_follow[123]:
        return tree
    if ctx.tokens.current() is None:
        return tree
    minimum = 0
    while minimum > 0 or \
           (ctx.tokens.current() is not None and \
            ctx.tokens.current().id in nonterminal_first.get(123)):
        tree.add(parse_command_part(ctx))
        ctx.nonterminal = "_gen8" # Horrible -- because parse_* can reset this
        minimum = max(minimum - 1, 0)
    return tree
def parse__gen9(ctx):
    tree = ParseTree(NonTerminal(103, '_gen9'))
    tree.list = True
    ctx.nonterminal = "_gen9"
    if ctx.tokens.current() is not None and \
       ctx.tokens.current().id not in nonterminal_first[103] and \
       ctx.tokens.current().id in nonterminal_follow[103]:
        return tree
    if ctx.tokens.current() is None:
        return tree
    minimum = 0
    while minimum > 0 or \
           (ctx.tokens.current() is not None and \
            ctx.tokens.current().id in nonterminal_first.get(103)):
        tree.add(parse_expression_placeholder_kv(ctx))
        ctx.nonterminal = "_gen9" # Horrible -- because parse_* can reset this
        minimum = max(minimum - 1, 0)
    return tree
def parse__gen13(ctx):
    current = ctx.tokens.current()
    rule = table[28][current.id] if current else -1
    tree = ParseTree(NonTerminal(93, '_gen13'))
    ctx.nonterminal = "_gen13"
    if current != None and current.id in nonterminal_follow[93] and current.id not in nonterminal_first[93]:
        return tree
    if current == None:
        return tree
    if rule == 51: # $_gen13 = $setter
        ctx.rule = rules[51]
        tree.astTransform = AstTransformSubstitution(0)
        subtree = parse_setter(ctx)
        tree.add(subtree)
        return tree
    return tree
def parse__gen16(ctx):
    current = ctx.tokens.current()
    rule = table[63][current.id] if current else -1
    tree = ParseTree(NonTerminal(128, '_gen16'))
    ctx.nonterminal = "_gen16"
    if current != None and current.id in nonterminal_follow[128] and current.id not in nonterminal_first[128]:
        return tree
    if current == None:
        return tree
    if rule == 70: # $_gen16 = $alias
        ctx.rule = rules[70]
        tree.astTransform = AstTransformSubstitution(0)
        subtree = parse_alias(ctx)
        tree.add(subtree)
        return tree
    return tree
def parse__gen17(ctx):
    current = ctx.tokens.current()
    rule = table[65][current.id] if current else -1
    tree = ParseTree(NonTerminal(130, '_gen17'))
    ctx.nonterminal = "_gen17"
    if current != None and current.id in nonterminal_follow[130] and current.id not in nonterminal_first[130]:
        return tree
    if current == None:
        return tree
    if rule == 72: # $_gen17 = $call_body
        ctx.rule = rules[72]
        tree.astTransform = AstTransformSubstitution(0)
        subtree = parse_call_body(ctx)
        tree.add(subtree)
        return tree
    return tree
def parse__gen5(ctx):
    current = ctx.tokens.current()
    rule = table[4][current.id] if current else -1
    tree = ParseTree(NonTerminal(69, '_gen5'))
    ctx.nonterminal = "_gen5"
    if current != None and current.id in nonterminal_follow[69] and current.id not in nonterminal_first[69]:
        return tree
    if current == None:
        return tree
    if rule == 18: # $_gen5 = $import_namespace
        ctx.rule = rules[18]
        tree.astTransform = AstTransformSubstitution(0)
        subtree = parse_import_namespace(ctx)
        tree.add(subtree)
        return tree
    return tree
def parse_alias(ctx):
    current = ctx.tokens.current()
    rule = table[61][current.id] if current else -1
    tree = ParseTree(NonTerminal(126, 'alias'))
    ctx.nonterminal = "alias"
    if current == None:
        raise ctx.errors.unexpected_eof()
    if rule == 77: # $alias = :as :identifier -> $1
        ctx.rule = rules[77]
        tree.astTransform = AstTransformSubstitution(1)
        t = expect(ctx, 21) # :as
        tree.add(t)
        t = expect(ctx, 12) # :identifier
        tree.add(t)
        return tree
    raise ctx.errors.unexpected_symbol(
      ctx.nonterminal,
      ctx.tokens.current(),
      [terminals[x] for x in nonterminal_first[126] if x >=0],
      rules[77]
    )
def parse_call(ctx):
    current = ctx.tokens.current()
    rule = table[60][current.id] if current else -1
    tree = ParseTree(NonTerminal(125, 'call'))
    ctx.nonterminal = "call"
    if current == None:
        raise ctx.errors.unexpected_eof()
    if rule == 74: # $call = :call :fqn $_gen16 $_gen17 -> Call( task=$1, alias=$2, body=$3 )
        ctx.rule = rules[74]
        ast_parameters = OrderedDict([
            ('task', 1),
            ('alias', 2),
            ('body', 3),
        ])
        tree.astTransform = AstTransformNodeCreator('Call', ast_parameters)
        t = expect(ctx, 41) # :call
        tree.add(t)
        t = expect(ctx, 13) # :fqn
        tree.add(t)
        subtree = parse__gen16(ctx)
        tree.add(subtree)
        subtree = parse__gen17(ctx)
        tree.add(subtree)
        return tree
    raise ctx.errors.unexpected_symbol(
      ctx.nonterminal,
      ctx.tokens.current(),
      [terminals[x] for x in nonterminal_first[125] if x >=0],
      rules[74]
    )
def parse_call_body(ctx):
    current = ctx.tokens.current()
    rule = table[67][current.id] if current else -1
    tree = ParseTree(NonTerminal(132, 'call_body'))
    ctx.nonterminal = "call_body"
    if current == None:
        raise ctx.errors.unexpected_eof()
    if rule == 76: # $call_body = :lbrace :input :colon $_gen18 :rbrace -> CallBody( inputs=$3 )
        ctx.rule = rules[76]
        ast_parameters = OrderedDict([
            ('inputs', 3),
        ])
        tree.astTransform = AstTransformNodeCreator('CallBody', ast_parameters)
        t = expect(ctx, 26) # :lbrace
        tree.add(t)
        t = expect(ctx, 43) # :input
        tree.add(t)
        t = expect(ctx, 9) # :colon
        tree.add(t)
        subtree = parse__gen18(ctx)
        tree.add(subtree)
        t = expect(ctx, 64) # :rbrace
        tree.add(t)
        return tree
    raise ctx.errors.unexpected_symbol(
      ctx.nonterminal,
      ctx.tokens.current(),
      [terminals[x] for x in nonterminal_first[132] if x >=0],
      rules[76]
    )
def parse_command(ctx):
    current = ctx.tokens.current()
    rule = table[68][current.id] if current else -1
    tree = ParseTree(NonTerminal(133, 'command'))
    ctx.nonterminal = "command"
    if current == None:
        raise ctx.errors.unexpected_eof()
    if rule == 34: # $command = :raw_command :raw_cmd_start $_gen8 :raw_cmd_end -> RawCommand( parts=$2 )
        ctx.rule = rules[34]
        ast_parameters = OrderedDict([
            ('parts', 2),
        ])
        tree.astTransform = AstTransformNodeCreator('RawCommand', ast_parameters)
        t = expect(ctx, 59) # :raw_command
        tree.add(t)
        t = expect(ctx, 52) # :raw_cmd_start
        tree.add(t)
        subtree = parse__gen8(ctx)
        tree.add(subtree)
        t = expect(ctx, 2) # :raw_cmd_end
        tree.add(t)
        return tree
    raise ctx.errors.unexpected_symbol(
      ctx.nonterminal,
      ctx.tokens.current(),
      [terminals[x] for x in nonterminal_first[133] if x >=0],
      rules[34]
    )
def parse_command_part(ctx):
    current = ctx.tokens.current()
    rule = table[42][current.id] if current else -1
    tree = ParseTree(NonTerminal(107, 'command_part'))
    ctx.nonterminal = "command_part"
    if current == None:
        raise ctx.errors.unexpected_eof()
    if rule == 35: # $command_part = :cmd_part
        ctx.rule = rules[35]
        tree.astTransform = AstTransformSubstitution(0)
        t = expect(ctx, 63) # :cmd_part
        tree.add(t)
        return tree
    elif rule == 36: # $command_part = $expression_placeholder
        ctx.rule = rules[36]
        tree.astTransform = AstTransformSubstitution(0)
        subtree = parse_expression_placeholder(ctx)
        tree.add(subtree)
        return tree
    raise ctx.errors.unexpected_symbol(
      ctx.nonterminal,
      ctx.tokens.current(),
      [terminals[x] for x in nonterminal_first[107] if x >=0],
      rules[36]
    )
def parse_declaration(ctx):
    current = ctx.tokens.current()
    rule = table[57][current.id] if current else -1
    tree = ParseTree(NonTerminal(122, 'declaration'))
    ctx.nonterminal = "declaration"
    if current == None:
        raise ctx.errors.unexpected_eof()
    if rule == 54: # $declaration = $type_e :identifier $setter -> Declaration( type=$0, name=$1, expression=$2 )
        ctx.rule = rules[54]
        ast_parameters = OrderedDict([
            ('type', 0),
            ('name', 1),
            ('expression', 2),
        ])
        tree.astTransform = AstTransformNodeCreator('Declaration', ast_parameters)
        subtree = parse_type_e(ctx)
        tree.add(subtree)
        t = expect(ctx, 12) # :identifier
        tree.add(t)
        subtree = parse_setter(ctx)
        tree.add(subtree)
        return tree
    raise ctx.errors.unexpected_symbol(
      ctx.nonterminal,
      ctx.tokens.current(),
      [terminals[x] for x in nonterminal_first[122] if x >=0],
      rules[54]
    )
def parse_document(ctx):
    current = ctx.tokens.current()
    rule = table[43][current.id] if current else -1
    tree = ParseTree(NonTerminal(108, 'document'))
    ctx.nonterminal = "document"
    if current == None:
        raise ctx.errors.unexpected_eof()
    if rule == 2: # $document = $version $_gen0 $_gen1 -> Draft3File( version=$0, imports=$1, body=$2 )
        ctx.rule = rules[2]
        ast_parameters = OrderedDict([
            ('version', 0),
            ('imports', 1),
            ('body', 2),
        ])
        tree.astTransform = AstTransformNodeCreator('Draft3File', ast_parameters)
        subtree = parse_version(ctx)
        tree.add(subtree)
        subtree = parse__gen0(ctx)
        tree.add(subtree)
        subtree = parse__gen1(ctx)
        tree.add(subtree)
        return tree
    raise ctx.errors.unexpected_symbol(
      ctx.nonterminal,
      ctx.tokens.current(),
      [terminals[x] for x in nonterminal_first[108] if x >=0],
      rules[2]
    )
def parse_expression_placeholder(ctx):
    current = ctx.tokens.current()
    rule = table[45][current.id] if current else -1
    tree = ParseTree(NonTerminal(110, 'expression_placeholder'))
    ctx.nonterminal = "expression_placeholder"
    if current == None:
        raise ctx.errors.unexpected_eof()
    if rule == 38: # $expression_placeholder = :expression_placeholder_start $_gen9 $e :expression_placeholder_end -> ExpressionPlaceholder( attributes=$1, expr=$2 )
        ctx.rule = rules[38]
        ast_parameters = OrderedDict([
            ('attributes', 1),
            ('expr', 2),
        ])
        tree.astTransform = AstTransformNodeCreator('ExpressionPlaceholder', ast_parameters)
        t = expect(ctx, 20) # :expression_placeholder_start
        tree.add(t)
        subtree = parse__gen9(ctx)
        tree.add(subtree)
        subtree = parse_e(ctx)
        tree.add(subtree)
        t = expect(ctx, 18) # :expression_placeholder_end
        tree.add(t)
        return tree
    raise ctx.errors.unexpected_symbol(
      ctx.nonterminal,
      ctx.tokens.current(),
      [terminals[x] for x in nonterminal_first[110] if x >=0],
      rules[38]
    )
def parse_expression_placeholder_kv(ctx):
    current = ctx.tokens.current()
    rule = table[37][current.id] if current else -1
    tree = ParseTree(NonTerminal(102, 'expression_placeholder_kv'))
    ctx.nonterminal = "expression_placeholder_kv"
    if current == None:
        raise ctx.errors.unexpected_eof()
    if rule == 39: # $expression_placeholder_kv = :cmd_attr_hint :identifier :equal $e -> ExpressionPlaceholderAttr( key=$1, value=$3 )
        ctx.rule = rules[39]
        ast_parameters = OrderedDict([
            ('key', 1),
            ('value', 3),
        ])
        tree.astTransform = AstTransformNodeCreator('ExpressionPlaceholderAttr', ast_parameters)
        t = expect(ctx, 14) # :cmd_attr_hint
        tree.add(t)
        t = expect(ctx, 12) # :identifier
        tree.add(t)
        t = expect(ctx, 27) # :equal
        tree.add(t)
        subtree = parse_e(ctx)
        tree.add(subtree)
        return tree
    raise ctx.errors.unexpected_symbol(
      ctx.nonterminal,
      ctx.tokens.current(),
      [terminals[x] for x in nonterminal_first[102] if x >=0],
      rules[39]
    )
def parse_file_body_element(ctx):
    current = ctx.tokens.current()
    rule = table[7][current.id] if current else -1
    tree = ParseTree(NonTerminal(72, 'file_body_element'))
    ctx.nonterminal = "file_body_element"
    if current == None:
        raise ctx.errors.unexpected_eof()
    if rule == 3: # $file_body_element = $workflow
        ctx.rule = rules[3]
        tree.astTransform = AstTransformSubstitution(0)
        subtree = parse_workflow(ctx)
        tree.add(subtree)
        return tree
    elif rule == 4: # $file_body_element = $task
        ctx.rule = rules[4]
        tree.astTransform = AstTransformSubstitution(0)
        subtree = parse_task(ctx)
        tree.add(subtree)
        return tree
    elif rule == 5: # $file_body_element = $struct
        ctx.rule = rules[5]
        tree.astTransform = AstTransformSubstitution(0)
        subtree = parse_struct(ctx)
        tree.add(subtree)
        return tree
    raise ctx.errors.unexpected_symbol(
      ctx.nonterminal,
      ctx.tokens.current(),
      [terminals[x] for x in nonterminal_first[72] if x >=0],
      rules[5]
    )
def parse_if_stmt(ctx):
    current = ctx.tokens.current()
    rule = table[23][current.id] if current else -1
    tree = ParseTree(NonTerminal(88, 'if_stmt'))
    ctx.nonterminal = "if_stmt"
    if current == None:
        raise ctx.errors.unexpected_eof()
    if rule == 80: # $if_stmt = :if :lparen $e :rparen :lbrace $_gen15 :rbrace -> If( expression=$2, body=$5 )
        ctx.rule = rules[80]
        ast_parameters = OrderedDict([
            ('expression', 2),
            ('body', 5),
        ])
        tree.astTransform = AstTransformNodeCreator('If', ast_parameters)
        t = expect(ctx, 57) # :if
        tree.add(t)
        t = expect(ctx, 8) # :lparen
        tree.add(t)
        subtree = parse_e(ctx)
        tree.add(subtree)
        t = expect(ctx, 53) # :rparen
        tree.add(t)
        t = expect(ctx, 26) # :lbrace
        tree.add(t)
        subtree = parse__gen15(ctx)
        tree.add(subtree)
        t = expect(ctx, 64) # :rbrace
        tree.add(t)
        return tree
    raise ctx.errors.unexpected_symbol(
      ctx.nonterminal,
      ctx.tokens.current(),
      [terminals[x] for x in nonterminal_first[88] if x >=0],
      rules[80]
    )
def parse_import(ctx):
    current = ctx.tokens.current()
    rule = table[15][current.id] if current else -1
    tree = ParseTree(NonTerminal(80, 'import'))
    ctx.nonterminal = "import"
    if current == None:
        raise ctx.errors.unexpected_eof()
    if rule == 21: # $import = :import $static_string $_gen5 $_gen6 -> Import( uri=$1, namespace=$2, aliases=$3 )
        ctx.rule = rules[21]
        ast_parameters = OrderedDict([
            ('uri', 1),
            ('namespace', 2),
            ('aliases', 3),
        ])
        tree.astTransform = AstTransformNodeCreator('Import', ast_parameters)
        t = expect(ctx, 62) # :import
        tree.add(t)
        subtree = parse_static_string(ctx)
        tree.add(subtree)
        subtree = parse__gen5(ctx)
        tree.add(subtree)
        subtree = parse__gen6(ctx)
        tree.add(subtree)
        return tree
    raise ctx.errors.unexpected_symbol(
      ctx.nonterminal,
      ctx.tokens.current(),
      [terminals[x] for x in nonterminal_first[80] if x >=0],
      rules[21]
    )
def parse_import_alias(ctx):
    current = ctx.tokens.current()
    rule = table[34][current.id] if current else -1
    tree = ParseTree(NonTerminal(99, 'import_alias'))
    ctx.nonterminal = "import_alias"
    if current == None:
        raise ctx.errors.unexpected_eof()
    if rule == 23: # $import_alias = :alias :identifier :as :identifier -> ImportAlias( old_name=$1, new_name=$3 )
        ctx.rule = rules[23]
        ast_parameters = OrderedDict([
            ('old_name', 1),
            ('new_name', 3),
        ])
        tree.astTransform = AstTransformNodeCreator('ImportAlias', ast_parameters)
        t = expect(ctx, 23) # :alias
        tree.add(t)
        t = expect(ctx, 12) # :identifier
        tree.add(t)
        t = expect(ctx, 21) # :as
        tree.add(t)
        t = expect(ctx, 12) # :identifier
        tree.add(t)
        return tree
    raise ctx.errors.unexpected_symbol(
      ctx.nonterminal,
      ctx.tokens.current(),
      [terminals[x] for x in nonterminal_first[99] if x >=0],
      rules[23]
    )
def parse_import_namespace(ctx):
    current = ctx.tokens.current()
    rule = table[26][current.id] if current else -1
    tree = ParseTree(NonTerminal(91, 'import_namespace'))
    ctx.nonterminal = "import_namespace"
    if current == None:
        raise ctx.errors.unexpected_eof()
    if rule == 22: # $import_namespace = :as :identifier -> $1
        ctx.rule = rules[22]
        tree.astTransform = AstTransformSubstitution(1)
        t = expect(ctx, 21) # :as
        tree.add(t)
        t = expect(ctx, 12) # :identifier
        tree.add(t)
        return tree
    raise ctx.errors.unexpected_symbol(
      ctx.nonterminal,
      ctx.tokens.current(),
      [terminals[x] for x in nonterminal_first[91] if x >=0],
      rules[22]
    )
def parse_input_declaration(ctx):
    current = ctx.tokens.current()
    rule = table[69][current.id] if current else -1
    tree = ParseTree(NonTerminal(134, 'input_declaration'))
    ctx.nonterminal = "input_declaration"
    if current == None:
        raise ctx.errors.unexpected_eof()
    if rule == 53: # $input_declaration = $type_e :identifier $_gen13 -> InputDeclaration( type=$0, name=$1, expression=$2 )
        ctx.rule = rules[53]
        ast_parameters = OrderedDict([
            ('type', 0),
            ('name', 1),
            ('expression', 2),
        ])
        tree.astTransform = AstTransformNodeCreator('InputDeclaration', ast_parameters)
        subtree = parse_type_e(ctx)
        tree.add(subtree)
        t = expect(ctx, 12) # :identifier
        tree.add(t)
        subtree = parse__gen13(ctx)
        tree.add(subtree)
        return tree
    raise ctx.errors.unexpected_symbol(
      ctx.nonterminal,
      ctx.tokens.current(),
      [terminals[x] for x in nonterminal_first[134] if x >=0],
      rules[53]
    )
def parse_input_kv(ctx):
    current = ctx.tokens.current()
    rule = table[62][current.id] if current else -1
    tree = ParseTree(NonTerminal(127, 'input_kv'))
    ctx.nonterminal = "input_kv"
    if current == None:
        raise ctx.errors.unexpected_eof()
    if rule == 83: # $input_kv = :identifier :equal $e -> ObjectKV( key=$0, value=$2 )
        ctx.rule = rules[83]
        ast_parameters = OrderedDict([
            ('key', 0),
            ('value', 2),
        ])
        tree.astTransform = AstTransformNodeCreator('ObjectKV', ast_parameters)
        t = expect(ctx, 12) # :identifier
        tree.add(t)
        t = expect(ctx, 27) # :equal
        tree.add(t)
        subtree = parse_e(ctx)
        tree.add(subtree)
        return tree
    raise ctx.errors.unexpected_symbol(
      ctx.nonterminal,
      ctx.tokens.current(),
      [terminals[x] for x in nonterminal_first[127] if x >=0],
      rules[83]
    )
def parse_inputs(ctx):
    current = ctx.tokens.current()
    rule = table[17][current.id] if current else -1
    tree = ParseTree(NonTerminal(82, 'inputs'))
    ctx.nonterminal = "inputs"
    if current == None:
        raise ctx.errors.unexpected_eof()
    if rule == 41: # $inputs = :input :lbrace $_gen10 :rbrace -> Inputs( inputs=$2 )
        ctx.rule = rules[41]
        ast_parameters = OrderedDict([
            ('inputs', 2),
        ])
        tree.astTransform = AstTransformNodeCreator('Inputs', ast_parameters)
        t = expect(ctx, 43) # :input
        tree.add(t)
        t = expect(ctx, 26) # :lbrace
        tree.add(t)
        subtree = parse__gen10(ctx)
        tree.add(subtree)
        t = expect(ctx, 64) # :rbrace
        tree.add(t)
        return tree
    raise ctx.errors.unexpected_symbol(
      ctx.nonterminal,
      ctx.tokens.current(),
      [terminals[x] for x in nonterminal_first[82] if x >=0],
      rules[41]
    )
def parse_kv(ctx):
    current = ctx.tokens.current()
    rule = table[11][current.id] if current else -1
    tree = ParseTree(NonTerminal(76, 'kv'))
    ctx.nonterminal = "kv"
    if current == None:
        raise ctx.errors.unexpected_eof()
    if rule == 45: # $kv = :identifier :colon $e -> RuntimeAttribute( key=$0, value=$2 )
        ctx.rule = rules[45]
        ast_parameters = OrderedDict([
            ('key', 0),
            ('value', 2),
        ])
        tree.astTransform = AstTransformNodeCreator('RuntimeAttribute', ast_parameters)
        t = expect(ctx, 12) # :identifier
        tree.add(t)
        t = expect(ctx, 9) # :colon
        tree.add(t)
        subtree = parse_e(ctx)
        tree.add(subtree)
        return tree
    raise ctx.errors.unexpected_symbol(
      ctx.nonterminal,
      ctx.tokens.current(),
      [terminals[x] for x in nonterminal_first[76] if x >=0],
      rules[45]
    )
def parse_map_kv(ctx):
    current = ctx.tokens.current()
    rule = table[54][current.id] if current else -1
    tree = ParseTree(NonTerminal(119, 'map_kv'))
    ctx.nonterminal = "map_kv"
    if current == None:
        raise ctx.errors.unexpected_eof()
    if rule == 56: # $map_kv = $e :colon $e -> MapLiteralKv( key=$0, value=$2 )
        ctx.rule = rules[56]
        ast_parameters = OrderedDict([
            ('key', 0),
            ('value', 2),
        ])
        tree.astTransform = AstTransformNodeCreator('MapLiteralKv', ast_parameters)
        subtree = parse_e(ctx)
        tree.add(subtree)
        t = expect(ctx, 9) # :colon
        tree.add(t)
        subtree = parse_e(ctx)
        tree.add(subtree)
        return tree
    raise ctx.errors.unexpected_symbol(
      ctx.nonterminal,
      ctx.tokens.current(),
      [terminals[x] for x in nonterminal_first[119] if x >=0],
      rules[56]
    )
def parse_meta(ctx):
    current = ctx.tokens.current()
    rule = table[51][current.id] if current else -1
    tree = ParseTree(NonTerminal(116, 'meta'))
    ctx.nonterminal = "meta"
    if current == None:
        raise ctx.errors.unexpected_eof()
    if rule == 46: # $meta = :meta $meta_map -> Meta( map=$1 )
        ctx.rule = rules[46]
        ast_parameters = OrderedDict([
            ('map', 1),
        ])
        tree.astTransform = AstTransformNodeCreator('Meta', ast_parameters)
        t = expect(ctx, 17) # :meta
        tree.add(t)
        subtree = parse_meta_map(ctx)
        tree.add(subtree)
        return tree
    raise ctx.errors.unexpected_symbol(
      ctx.nonterminal,
      ctx.tokens.current(),
      [terminals[x] for x in nonterminal_first[116] if x >=0],
      rules[46]
    )
def parse_meta_kv(ctx):
    current = ctx.tokens.current()
    rule = table[66][current.id] if current else -1
    tree = ParseTree(NonTerminal(131, 'meta_kv'))
    ctx.nonterminal = "meta_kv"
    if current == None:
        raise ctx.errors.unexpected_eof()
    if rule == 50: # $meta_kv = :identifier :colon $meta_value -> MetaKvPair( key=$0, value=$2 )
        ctx.rule = rules[50]
        ast_parameters = OrderedDict([
            ('key', 0),
            ('value', 2),
        ])
        tree.astTransform = AstTransformNodeCreator('MetaKvPair', ast_parameters)
        t = expect(ctx, 12) # :identifier
        tree.add(t)
        t = expect(ctx, 9) # :colon
        tree.add(t)
        subtree = parse_meta_value(ctx)
        tree.add(subtree)
        return tree
    raise ctx.errors.unexpected_symbol(
      ctx.nonterminal,
      ctx.tokens.current(),
      [terminals[x] for x in nonterminal_first[131] if x >=0],
      rules[50]
    )
def parse_meta_map(ctx):
    current = ctx.tokens.current()
    rule = table[25][current.id] if current else -1
    tree = ParseTree(NonTerminal(90, 'meta_map'))
    ctx.nonterminal = "meta_map"
    if current == None:
        raise ctx.errors.unexpected_eof()
    if rule == 49: # $meta_map = :lbrace $_gen12 :rbrace -> $1
        ctx.rule = rules[49]
        tree.astTransform = AstTransformSubstitution(1)
        t = expect(ctx, 26) # :lbrace
        tree.add(t)
        subtree = parse__gen12(ctx)
        tree.add(subtree)
        t = expect(ctx, 64) # :rbrace
        tree.add(t)
        return tree
    raise ctx.errors.unexpected_symbol(
      ctx.nonterminal,
      ctx.tokens.current(),
      [terminals[x] for x in nonterminal_first[90] if x >=0],
      rules[49]
    )
def parse_object_kv(ctx):
    current = ctx.tokens.current()
    rule = table[49][current.id] if current else -1
    tree = ParseTree(NonTerminal(114, 'object_kv'))
    ctx.nonterminal = "object_kv"
    if current == None:
        raise ctx.errors.unexpected_eof()
    if rule == 82: # $object_kv = :identifier :colon $e -> ObjectKV( key=$0, value=$2 )
        ctx.rule = rules[82]
        ast_parameters = OrderedDict([
            ('key', 0),
            ('value', 2),
        ])
        tree.astTransform = AstTransformNodeCreator('ObjectKV', ast_parameters)
        t = expect(ctx, 12) # :identifier
        tree.add(t)
        t = expect(ctx, 9) # :colon
        tree.add(t)
        subtree = parse_e(ctx)
        tree.add(subtree)
        return tree
    raise ctx.errors.unexpected_symbol(
      ctx.nonterminal,
      ctx.tokens.current(),
      [terminals[x] for x in nonterminal_first[114] if x >=0],
      rules[82]
    )
def parse_output_kv(ctx):
    current = ctx.tokens.current()
    rule = table[46][current.id] if current else -1
    tree = ParseTree(NonTerminal(111, 'output_kv'))
    ctx.nonterminal = "output_kv"
    if current == None:
        raise ctx.errors.unexpected_eof()
    if rule == 59: # $output_kv = $type_e :identifier :equal $e -> Output( type=$0, name=$1, expression=$3 )
        ctx.rule = rules[59]
        ast_parameters = OrderedDict([
            ('type', 0),
            ('name', 1),
            ('expression', 3),
        ])
        tree.astTransform = AstTransformNodeCreator('Output', ast_parameters)
        subtree = parse_type_e(ctx)
        tree.add(subtree)
        t = expect(ctx, 12) # :identifier
        tree.add(t)
        t = expect(ctx, 27) # :equal
        tree.add(t)
        subtree = parse_e(ctx)
        tree.add(subtree)
        return tree
    raise ctx.errors.unexpected_symbol(
      ctx.nonterminal,
      ctx.tokens.current(),
      [terminals[x] for x in nonterminal_first[111] if x >=0],
      rules[59]
    )
def parse_outputs(ctx):
    current = ctx.tokens.current()
    rule = table[21][current.id] if current else -1
    tree = ParseTree(NonTerminal(86, 'outputs'))
    ctx.nonterminal = "outputs"
    if current == None:
        raise ctx.errors.unexpected_eof()
    if rule == 58: # $outputs = :output :lbrace $_gen14 :rbrace -> Outputs( outputs=$2 )
        ctx.rule = rules[58]
        ast_parameters = OrderedDict([
            ('outputs', 2),
        ])
        tree.astTransform = AstTransformNodeCreator('Outputs', ast_parameters)
        t = expect(ctx, 40) # :output
        tree.add(t)
        t = expect(ctx, 26) # :lbrace
        tree.add(t)
        subtree = parse__gen14(ctx)
        tree.add(subtree)
        t = expect(ctx, 64) # :rbrace
        tree.add(t)
        return tree
    raise ctx.errors.unexpected_symbol(
      ctx.nonterminal,
      ctx.tokens.current(),
      [terminals[x] for x in nonterminal_first[86] if x >=0],
      rules[58]
    )
def parse_parameter_meta(ctx):
    current = ctx.tokens.current()
    rule = table[10][current.id] if current else -1
    tree = ParseTree(NonTerminal(75, 'parameter_meta'))
    ctx.nonterminal = "parameter_meta"
    if current == None:
        raise ctx.errors.unexpected_eof()
    if rule == 47: # $parameter_meta = :parameter_meta $meta_map -> ParameterMeta( map=$1 )
        ctx.rule = rules[47]
        ast_parameters = OrderedDict([
            ('map', 1),
        ])
        tree.astTransform = AstTransformNodeCreator('ParameterMeta', ast_parameters)
        t = expect(ctx, 28) # :parameter_meta
        tree.add(t)
        subtree = parse_meta_map(ctx)
        tree.add(subtree)
        return tree
    raise ctx.errors.unexpected_symbol(
      ctx.nonterminal,
      ctx.tokens.current(),
      [terminals[x] for x in nonterminal_first[75] if x >=0],
      rules[47]
    )
def parse_rt_map(ctx):
    current = ctx.tokens.current()
    rule = table[35][current.id] if current else -1
    tree = ParseTree(NonTerminal(100, 'rt_map'))
    ctx.nonterminal = "rt_map"
    if current == None:
        raise ctx.errors.unexpected_eof()
    if rule == 44: # $rt_map = :lbrace $_gen11 :rbrace -> $1
        ctx.rule = rules[44]
        tree.astTransform = AstTransformSubstitution(1)
        t = expect(ctx, 26) # :lbrace
        tree.add(t)
        subtree = parse__gen11(ctx)
        tree.add(subtree)
        t = expect(ctx, 64) # :rbrace
        tree.add(t)
        return tree
    raise ctx.errors.unexpected_symbol(
      ctx.nonterminal,
      ctx.tokens.current(),
      [terminals[x] for x in nonterminal_first[100] if x >=0],
      rules[44]
    )
def parse_runtime(ctx):
    current = ctx.tokens.current()
    rule = table[20][current.id] if current else -1
    tree = ParseTree(NonTerminal(85, 'runtime'))
    ctx.nonterminal = "runtime"
    if current == None:
        raise ctx.errors.unexpected_eof()
    if rule == 42: # $runtime = :runtime $rt_map -> Runtime( map=$1 )
        ctx.rule = rules[42]
        ast_parameters = OrderedDict([
            ('map', 1),
        ])
        tree.astTransform = AstTransformNodeCreator('Runtime', ast_parameters)
        t = expect(ctx, 24) # :runtime
        tree.add(t)
        subtree = parse_rt_map(ctx)
        tree.add(subtree)
        return tree
    raise ctx.errors.unexpected_symbol(
      ctx.nonterminal,
      ctx.tokens.current(),
      [terminals[x] for x in nonterminal_first[85] if x >=0],
      rules[42]
    )
def parse_scatter(ctx):
    current = ctx.tokens.current()
    rule = table[36][current.id] if current else -1
    tree = ParseTree(NonTerminal(101, 'scatter'))
    ctx.nonterminal = "scatter"
    if current == None:
        raise ctx.errors.unexpected_eof()
    if rule == 81: # $scatter = :scatter :lparen :identifier :in $e :rparen :lbrace $_gen15 :rbrace -> Scatter( item=$2, collection=$4, body=$7 )
        ctx.rule = rules[81]
        ast_parameters = OrderedDict([
            ('item', 2),
            ('collection', 4),
            ('body', 7),
        ])
        tree.astTransform = AstTransformNodeCreator('Scatter', ast_parameters)
        t = expect(ctx, 25) # :scatter
        tree.add(t)
        t = expect(ctx, 8) # :lparen
        tree.add(t)
        t = expect(ctx, 12) # :identifier
        tree.add(t)
        t = expect(ctx, 48) # :in
        tree.add(t)
        subtree = parse_e(ctx)
        tree.add(subtree)
        t = expect(ctx, 53) # :rparen
        tree.add(t)
        t = expect(ctx, 26) # :lbrace
        tree.add(t)
        subtree = parse__gen15(ctx)
        tree.add(subtree)
        t = expect(ctx, 64) # :rbrace
        tree.add(t)
        return tree
    raise ctx.errors.unexpected_symbol(
      ctx.nonterminal,
      ctx.tokens.current(),
      [terminals[x] for x in nonterminal_first[101] if x >=0],
      rules[81]
    )
def parse_setter(ctx):
    current = ctx.tokens.current()
    rule = table[56][current.id] if current else -1
    tree = ParseTree(NonTerminal(121, 'setter'))
    ctx.nonterminal = "setter"
    if current == None:
        raise ctx.errors.unexpected_eof()
    if rule == 55: # $setter = :equal $e -> $1
        ctx.rule = rules[55]
        tree.astTransform = AstTransformSubstitution(1)
        t = expect(ctx, 27) # :equal
        tree.add(t)
        subtree = parse_e(ctx)
        tree.add(subtree)
        return tree
    raise ctx.errors.unexpected_symbol(
      ctx.nonterminal,
      ctx.tokens.current(),
      [terminals[x] for x in nonterminal_first[121] if x >=0],
      rules[55]
    )
def parse_static_string(ctx):
    current = ctx.tokens.current()
    rule = table[41][current.id] if current else -1
    tree = ParseTree(NonTerminal(106, 'static_string'))
    ctx.nonterminal = "static_string"
    if current == None:
        raise ctx.errors.unexpected_eof()
    if rule == 11: # $static_string = :quote $_gen3 :quote -> StaticString( value=$1 )
        ctx.rule = rules[11]
        ast_parameters = OrderedDict([
            ('value', 1),
        ])
        tree.astTransform = AstTransformNodeCreator('StaticString', ast_parameters)
        t = expect(ctx, 37) # :quote
        tree.add(t)
        subtree = parse__gen3(ctx)
        tree.add(subtree)
        t = expect(ctx, 37) # :quote
        tree.add(t)
        return tree
    raise ctx.errors.unexpected_symbol(
      ctx.nonterminal,
      ctx.tokens.current(),
      [terminals[x] for x in nonterminal_first[106] if x >=0],
      rules[11]
    )
def parse_static_string_piece(ctx):
    current = ctx.tokens.current()
    rule = table[14][current.id] if current else -1
    tree = ParseTree(NonTerminal(79, 'static_string_piece'))
    ctx.nonterminal = "static_string_piece"
    if current == None:
        raise ctx.errors.unexpected_eof()
    if rule == 14: # $static_string_piece = :string
        ctx.rule = rules[14]
        tree.astTransform = AstTransformSubstitution(0)
        t = expect(ctx, 36) # :string
        tree.add(t)
        return tree
    elif rule == 15: # $static_string_piece = :escape
        ctx.rule = rules[15]
        tree.astTransform = AstTransformSubstitution(0)
        t = expect(ctx, 51) # :escape
        tree.add(t)
        return tree
    raise ctx.errors.unexpected_symbol(
      ctx.nonterminal,
      ctx.tokens.current(),
      [terminals[x] for x in nonterminal_first[79] if x >=0],
      rules[15]
    )
def parse_string_literal(ctx):
    current = ctx.tokens.current()
    rule = table[8][current.id] if current else -1
    tree = ParseTree(NonTerminal(73, 'string_literal'))
    ctx.nonterminal = "string_literal"
    if current == None:
        raise ctx.errors.unexpected_eof()
    if rule == 13: # $string_literal = :quote $_gen4 :quote -> StringLiteral( pieces=$1 )
        ctx.rule = rules[13]
        ast_parameters = OrderedDict([
            ('pieces', 1),
        ])
        tree.astTransform = AstTransformNodeCreator('StringLiteral', ast_parameters)
        t = expect(ctx, 37) # :quote
        tree.add(t)
        subtree = parse__gen4(ctx)
        tree.add(subtree)
        t = expect(ctx, 37) # :quote
        tree.add(t)
        return tree
    raise ctx.errors.unexpected_symbol(
      ctx.nonterminal,
      ctx.tokens.current(),
      [terminals[x] for x in nonterminal_first[73] if x >=0],
      rules[13]
    )
def parse_string_piece(ctx):
    current = ctx.tokens.current()
    rule = table[5][current.id] if current else -1
    tree = ParseTree(NonTerminal(70, 'string_piece'))
    ctx.nonterminal = "string_piece"
    if current == None:
        raise ctx.errors.unexpected_eof()
    if rule == 16: # $string_piece = $static_string_piece
        ctx.rule = rules[16]
        tree.astTransform = AstTransformSubstitution(0)
        subtree = parse_static_string_piece(ctx)
        tree.add(subtree)
        return tree
    elif rule == 17: # $string_piece = $expression_placeholder
        ctx.rule = rules[17]
        tree.astTransform = AstTransformSubstitution(0)
        subtree = parse_expression_placeholder(ctx)
        tree.add(subtree)
        return tree
    raise ctx.errors.unexpected_symbol(
      ctx.nonterminal,
      ctx.tokens.current(),
      [terminals[x] for x in nonterminal_first[70] if x >=0],
      rules[17]
    )
def parse_struct(ctx):
    current = ctx.tokens.current()
    rule = table[1][current.id] if current else -1
    tree = ParseTree(NonTerminal(66, 'struct'))
    ctx.nonterminal = "struct"
    if current == None:
        raise ctx.errors.unexpected_eof()
    if rule == 8: # $struct = :struct :identifier :lbrace $_gen2 :rbrace -> Struct( name=$1, entries=$3 )
        ctx.rule = rules[8]
        ast_parameters = OrderedDict([
            ('name', 1),
            ('entries', 3),
        ])
        tree.astTransform = AstTransformNodeCreator('Struct', ast_parameters)
        t = expect(ctx, 6) # :struct
        tree.add(t)
        t = expect(ctx, 12) # :identifier
        tree.add(t)
        t = expect(ctx, 26) # :lbrace
        tree.add(t)
        subtree = parse__gen2(ctx)
        tree.add(subtree)
        t = expect(ctx, 64) # :rbrace
        tree.add(t)
        return tree
    raise ctx.errors.unexpected_symbol(
      ctx.nonterminal,
      ctx.tokens.current(),
      [terminals[x] for x in nonterminal_first[66] if x >=0],
      rules[8]
    )
def parse_struct_declaration(ctx):
    current = ctx.tokens.current()
    rule = table[6][current.id] if current else -1
    tree = ParseTree(NonTerminal(71, 'struct_declaration'))
    ctx.nonterminal = "struct_declaration"
    if current == None:
        raise ctx.errors.unexpected_eof()
    if rule == 9: # $struct_declaration = $type_e :identifier -> StructEntry( type=$0, name=$1 )
        ctx.rule = rules[9]
        ast_parameters = OrderedDict([
            ('type', 0),
            ('name', 1),
        ])
        tree.astTransform = AstTransformNodeCreator('StructEntry', ast_parameters)
        subtree = parse_type_e(ctx)
        tree.add(subtree)
        t = expect(ctx, 12) # :identifier
        tree.add(t)
        return tree
    raise ctx.errors.unexpected_symbol(
      ctx.nonterminal,
      ctx.tokens.current(),
      [terminals[x] for x in nonterminal_first[71] if x >=0],
      rules[9]
    )
def parse_task(ctx):
    current = ctx.tokens.current()
    rule = table[13][current.id] if current else -1
    tree = ParseTree(NonTerminal(78, 'task'))
    ctx.nonterminal = "task"
    if current == None:
        raise ctx.errors.unexpected_eof()
    if rule == 25: # $task = :task :identifier :lbrace $_gen7 :rbrace -> Task( name=$1, sections=$3 )
        ctx.rule = rules[25]
        ast_parameters = OrderedDict([
            ('name', 1),
            ('sections', 3),
        ])
        tree.astTransform = AstTransformNodeCreator('Task', ast_parameters)
        t = expect(ctx, 5) # :task
        tree.add(t)
        t = expect(ctx, 12) # :identifier
        tree.add(t)
        t = expect(ctx, 26) # :lbrace
        tree.add(t)
        subtree = parse__gen7(ctx)
        tree.add(subtree)
        t = expect(ctx, 64) # :rbrace
        tree.add(t)
        return tree
    raise ctx.errors.unexpected_symbol(
      ctx.nonterminal,
      ctx.tokens.current(),
      [terminals[x] for x in nonterminal_first[78] if x >=0],
      rules[25]
    )
def parse_task_sections(ctx):
    current = ctx.tokens.current()
    rule = table[27][current.id] if current else -1
    tree = ParseTree(NonTerminal(92, 'task_sections'))
    ctx.nonterminal = "task_sections"
    if current == None:
        raise ctx.errors.unexpected_eof()
    if rule == 26: # $task_sections = $command
        ctx.rule = rules[26]
        tree.astTransform = AstTransformSubstitution(0)
        subtree = parse_command(ctx)
        tree.add(subtree)
        return tree
    elif rule == 27: # $task_sections = $inputs
        ctx.rule = rules[27]
        tree.astTransform = AstTransformSubstitution(0)
        subtree = parse_inputs(ctx)
        tree.add(subtree)
        return tree
    elif rule == 28: # $task_sections = $outputs
        ctx.rule = rules[28]
        tree.astTransform = AstTransformSubstitution(0)
        subtree = parse_outputs(ctx)
        tree.add(subtree)
        return tree
    elif rule == 29: # $task_sections = $runtime
        ctx.rule = rules[29]
        tree.astTransform = AstTransformSubstitution(0)
        subtree = parse_runtime(ctx)
        tree.add(subtree)
        return tree
    elif rule == 30: # $task_sections = $parameter_meta
        ctx.rule = rules[30]
        tree.astTransform = AstTransformSubstitution(0)
        subtree = parse_parameter_meta(ctx)
        tree.add(subtree)
        return tree
    elif rule == 31: # $task_sections = $meta
        ctx.rule = rules[31]
        tree.astTransform = AstTransformSubstitution(0)
        subtree = parse_meta(ctx)
        tree.add(subtree)
        return tree
    elif rule == 32: # $task_sections = $declaration
        ctx.rule = rules[32]
        tree.astTransform = AstTransformSubstitution(0)
        subtree = parse_declaration(ctx)
        tree.add(subtree)
        return tree
    raise ctx.errors.unexpected_symbol(
      ctx.nonterminal,
      ctx.tokens.current(),
      [terminals[x] for x in nonterminal_first[92] if x >=0],
      rules[32]
    )
def parse_version(ctx):
    current = ctx.tokens.current()
    rule = table[70][current.id] if current else -1
    tree = ParseTree(NonTerminal(135, 'version'))
    ctx.nonterminal = "version"
    if current == None:
        raise ctx.errors.unexpected_eof()
    if rule == 6: # $version = :version :version_name -> VersionDeclaration( v=$1 )
        ctx.rule = rules[6]
        ast_parameters = OrderedDict([
            ('v', 1),
        ])
        tree.astTransform = AstTransformNodeCreator('VersionDeclaration', ast_parameters)
        t = expect(ctx, 31) # :version
        tree.add(t)
        t = expect(ctx, 7) # :version_name
        tree.add(t)
        return tree
    raise ctx.errors.unexpected_symbol(
      ctx.nonterminal,
      ctx.tokens.current(),
      [terminals[x] for x in nonterminal_first[135] if x >=0],
      rules[6]
    )
def parse_wf_body_element(ctx):
    current = ctx.tokens.current()
    rule = table[55][current.id] if current else -1
    tree = ParseTree(NonTerminal(120, 'wf_body_element'))
    ctx.nonterminal = "wf_body_element"
    if current == None:
        raise ctx.errors.unexpected_eof()
    if rule == 62: # $wf_body_element = $call
        ctx.rule = rules[62]
        tree.astTransform = AstTransformSubstitution(0)
        subtree = parse_call(ctx)
        tree.add(subtree)
        return tree
    elif rule == 63: # $wf_body_element = $declaration
        ctx.rule = rules[63]
        tree.astTransform = AstTransformSubstitution(0)
        subtree = parse_declaration(ctx)
        tree.add(subtree)
        return tree
    elif rule == 64: # $wf_body_element = $if_stmt
        ctx.rule = rules[64]
        tree.astTransform = AstTransformSubstitution(0)
        subtree = parse_if_stmt(ctx)
        tree.add(subtree)
        return tree
    elif rule == 65: # $wf_body_element = $scatter
        ctx.rule = rules[65]
        tree.astTransform = AstTransformSubstitution(0)
        subtree = parse_scatter(ctx)
        tree.add(subtree)
        return tree
    elif rule == 66: # $wf_body_element = $inputs
        ctx.rule = rules[66]
        tree.astTransform = AstTransformSubstitution(0)
        subtree = parse_inputs(ctx)
        tree.add(subtree)
        return tree
    elif rule == 67: # $wf_body_element = $outputs
        ctx.rule = rules[67]
        tree.astTransform = AstTransformSubstitution(0)
        subtree = parse_outputs(ctx)
        tree.add(subtree)
        return tree
    elif rule == 68: # $wf_body_element = $wf_parameter_meta
        ctx.rule = rules[68]
        tree.astTransform = AstTransformSubstitution(0)
        subtree = parse_wf_parameter_meta(ctx)
        tree.add(subtree)
        return tree
    elif rule == 69: # $wf_body_element = $wf_meta
        ctx.rule = rules[69]
        tree.astTransform = AstTransformSubstitution(0)
        subtree = parse_wf_meta(ctx)
        tree.add(subtree)
        return tree
    raise ctx.errors.unexpected_symbol(
      ctx.nonterminal,
      ctx.tokens.current(),
      [terminals[x] for x in nonterminal_first[120] if x >=0],
      rules[69]
    )
def parse_wf_meta(ctx):
    current = ctx.tokens.current()
    rule = table[9][current.id] if current else -1
    tree = ParseTree(NonTerminal(74, 'wf_meta'))
    ctx.nonterminal = "wf_meta"
    if current == None:
        raise ctx.errors.unexpected_eof()
    if rule == 79: # $wf_meta = :meta $meta_map -> Meta( map=$1 )
        ctx.rule = rules[79]
        ast_parameters = OrderedDict([
            ('map', 1),
        ])
        tree.astTransform = AstTransformNodeCreator('Meta', ast_parameters)
        t = expect(ctx, 17) # :meta
        tree.add(t)
        subtree = parse_meta_map(ctx)
        tree.add(subtree)
        return tree
    raise ctx.errors.unexpected_symbol(
      ctx.nonterminal,
      ctx.tokens.current(),
      [terminals[x] for x in nonterminal_first[74] if x >=0],
      rules[79]
    )
def parse_wf_parameter_meta(ctx):
    current = ctx.tokens.current()
    rule = table[32][current.id] if current else -1
    tree = ParseTree(NonTerminal(97, 'wf_parameter_meta'))
    ctx.nonterminal = "wf_parameter_meta"
    if current == None:
        raise ctx.errors.unexpected_eof()
    if rule == 78: # $wf_parameter_meta = :parameter_meta $meta_map -> ParameterMeta( map=$1 )
        ctx.rule = rules[78]
        ast_parameters = OrderedDict([
            ('map', 1),
        ])
        tree.astTransform = AstTransformNodeCreator('ParameterMeta', ast_parameters)
        t = expect(ctx, 28) # :parameter_meta
        tree.add(t)
        subtree = parse_meta_map(ctx)
        tree.add(subtree)
        return tree
    raise ctx.errors.unexpected_symbol(
      ctx.nonterminal,
      ctx.tokens.current(),
      [terminals[x] for x in nonterminal_first[97] if x >=0],
      rules[78]
    )
def parse_workflow(ctx):
    current = ctx.tokens.current()
    rule = table[59][current.id] if current else -1
    tree = ParseTree(NonTerminal(124, 'workflow'))
    ctx.nonterminal = "workflow"
    if current == None:
        raise ctx.errors.unexpected_eof()
    if rule == 61: # $workflow = :workflow :identifier :lbrace $_gen15 :rbrace -> Workflow( name=$1, body=$3 )
        ctx.rule = rules[61]
        ast_parameters = OrderedDict([
            ('name', 1),
            ('body', 3),
        ])
        tree.astTransform = AstTransformNodeCreator('Workflow', ast_parameters)
        t = expect(ctx, 38) # :workflow
        tree.add(t)
        t = expect(ctx, 12) # :identifier
        tree.add(t)
        t = expect(ctx, 26) # :lbrace
        tree.add(t)
        subtree = parse__gen15(ctx)
        tree.add(subtree)
        t = expect(ctx, 64) # :rbrace
        tree.add(t)
        return tree
    raise ctx.errors.unexpected_symbol(
      ctx.nonterminal,
      ctx.tokens.current(),
      [terminals[x] for x in nonterminal_first[124] if x >=0],
      rules[61]
    )
# Lexer Code #
# START USER CODE
def init():
    return {
        'context': None,
        'replacements': {
            re.compile(r"\\n"): 0x000A,
            re.compile(r"\\r"): 0x000D,
            re.compile(r"\\b"): 0x0008,
            re.compile(r"\\t"): 0x0009,
            re.compile(r"\\a"): 0x0007,
            re.compile(r"\\v"): 0x000B,
            re.compile(r'\\"'): 0x0022,
            re.compile(r"\\'"): 0x0027,
            re.compile(r"\\\?"): 0x003F
        },
        'escapes': {
            re.compile(r'(\\([0-7]{1,3}))'): 8,
            re.compile(r'(\\[xX]([0-9a-fA-F]{1,4}))'): 16,
            re.compile(r'(\\[uU]([0-9a-fA-F]{4}))'): 16
        }
    }
def workflow(ctx, terminal, source_string, line, col):
    ctx.user_context['context'] = 'workflow'
    default_action(ctx, terminal, source_string, line, col)
def task(ctx, terminal, source_string, line, col):
    ctx.user_context['context'] = 'task'
    default_action(ctx, terminal, source_string, line, col)
def output(ctx, terminal, source_string, line, col):
    if ctx.user_context['context'] == 'workflow':
        ctx.stack.append('wf_output')
    default_action(ctx, terminal, source_string, line, col)
# END USER CODE
def emit(ctx, terminal, source_string, line, col):
    if terminal:
        ctx.tokens.append(Terminal(terminals[terminal], terminal, source_string, ctx.resource, line, col))
def default_action(ctx, terminal, source_string, line, col):
    emit(ctx, terminal, source_string, line, col)
def post_filter(tokens):
    return tokens
def destroy(context):
    pass
class LexerStackPush:
    def __init__(self, mode):
        self.mode = mode
class LexerAction:
    def __init__(self, action):
        self.action = action
class LexerContext:
    def __init__(self, string, resource, errors, user_context):
        self.__dict__.update(locals())
        self.stack = ['default']
        self.line = 1
        self.col = 1
        self.tokens = []
        self.user_context = user_context
        self.re_match = None # https://docs.python.org/3/library/re.html#match-objects
class HermesLexer:
    regex = {
        'default': OrderedDict([
          (re.compile(r'#.*'), [
              # (terminal, group, function)
          ]),
          (re.compile(r'\s+'), [
              # (terminal, group, function)
          ]),
          (re.compile(r'^version(?![a-zA-Z0-9_])'), [
              # (terminal, group, function)
              ('version', 0, None),
              LexerStackPush('awaiting_version_name'),
          ]),
        ]),
        'main': OrderedDict([
          (re.compile(r'\s+'), [
              # (terminal, group, function)
          ]),
          (re.compile(r'/\*(.*?)\*/', re.DOTALL), [
              # (terminal, group, function)
          ]),
          (re.compile(r'#.*'), [
              # (terminal, group, function)
          ]),
          (re.compile(r'task(?![a-zA-Z0-9_])'), [
              # (terminal, group, function)
              ('task', 0, task),
          ]),
          (re.compile(r'(call)\s+'), [
              # (terminal, group, function)
              ('call', 1, None),
              LexerStackPush('task_fqn'),
          ]),
          (re.compile(r'workflow(?![a-zA-Z0-9_])'), [
              # (terminal, group, function)
              ('workflow', 0, workflow),
          ]),
          (re.compile(r'struct(?![a-zA-Z0-9_])'), [
              # (terminal, group, function)
              ('struct', 0, None),
          ]),
          (re.compile(r'import(?![a-zA-Z0-9_])'), [
              # (terminal, group, function)
              ('import', 0, None),
          ]),
          (re.compile(r'alias(?![a-zA-Z0-9_])'), [
              # (terminal, group, function)
              ('alias', 0, None),
          ]),
          (re.compile(r'input(?![a-zA-Z0-9_])'), [
              # (terminal, group, function)
              ('input', 0, None),
          ]),
          (re.compile(r'output(?![a-zA-Z0-9_])'), [
              # (terminal, group, function)
              ('output', 0, None),
          ]),
          (re.compile(r'as(?![a-zA-Z0-9_])'), [
              # (terminal, group, function)
              ('as', 0, None),
          ]),
          (re.compile(r'if(?![a-zA-Z0-9_])'), [
              # (terminal, group, function)
              ('if', 0, None),
          ]),
          (re.compile(r'then(?![a-zA-Z0-9_])'), [
              # (terminal, group, function)
              ('then', 0, None),
          ]),
          (re.compile(r'else(?![a-zA-Z0-9_])'), [
              # (terminal, group, function)
              ('else', 0, None),
          ]),
          (re.compile(r'runtime(?![a-zA-Z0-9_])'), [
              # (terminal, group, function)
              ('runtime', 0, None),
          ]),
          (re.compile(r'scatter(?![a-zA-Z0-9_])'), [
              # (terminal, group, function)
              ('scatter', 0, None),
              LexerStackPush('scatter'),
          ]),
          (re.compile(r'command\s*(?=<<<)'), [
              # (terminal, group, function)
              ('raw_command', 0, None),
              LexerStackPush('raw_command2'),
          ]),
          (re.compile(r'command\s*(?=\{)'), [
              # (terminal, group, function)
              ('raw_command', 0, None),
              LexerStackPush('raw_command'),
          ]),
          (re.compile(r'parameter_meta(?![a-zA-Z0-9_])'), [
              # (terminal, group, function)
              ('parameter_meta', 0, None),
          ]),
          (re.compile(r'meta(?![a-zA-Z0-9_])'), [
              # (terminal, group, function)
              ('meta', 0, None),
          ]),
          (re.compile(r'(true|false)(?![a-zA-Z0-9_])'), [
              # (terminal, group, function)
              ('boolean', 0, None),
          ]),
          (re.compile(r'(object)\s*(\{)'), [
              # (terminal, group, function)
              ('object', 0, None),
              ('lbrace', 0, None),
          ]),
          (re.compile(r'(Array|Map|Object|Pair|Boolean|Int|Float|Uri|File|Directory|String)(?![a-zA-Z0-9_])(?![a-zA-Z0-9_])'), [
              # (terminal, group, function)
              ('type', 0, None),
          ]),
          (re.compile(r'[a-zA-Z]([a-zA-Z0-9_])*'), [
              # (terminal, group, function)
              ('identifier', 0, None),
          ]),
          (re.compile(r'null'), [
              # (terminal, group, function)
              ('null', 0, None),
          ]),
          (re.compile(r':'), [
              # (terminal, group, function)
              ('colon', 0, None),
          ]),
          (re.compile(r','), [
              # (terminal, group, function)
              ('comma', 0, None),
          ]),
          (re.compile(r'=='), [
              # (terminal, group, function)
              ('double_equal', 0, None),
          ]),
          (re.compile(r'\|\|'), [
              # (terminal, group, function)
              ('double_pipe', 0, None),
          ]),
          (re.compile(r'\&\&'), [
              # (terminal, group, function)
              ('double_ampersand', 0, None),
          ]),
          (re.compile(r'!='), [
              # (terminal, group, function)
              ('not_equal', 0, None),
          ]),
          (re.compile(r'='), [
              # (terminal, group, function)
              ('equal', 0, None),
          ]),
          (re.compile(r'\.'), [
              # (terminal, group, function)
              ('dot', 0, None),
          ]),
          (re.compile(r'\{'), [
              # (terminal, group, function)
              ('lbrace', 0, None),
          ]),
          (re.compile(r'\}'), [
              # (terminal, group, function)
              ('rbrace', 0, None),
          ]),
          (re.compile(r'\('), [
              # (terminal, group, function)
              ('lparen', 0, None),
          ]),
          (re.compile(r'\)'), [
              # (terminal, group, function)
              ('rparen', 0, None),
          ]),
          (re.compile(r'\['), [
              # (terminal, group, function)
              ('lsquare', 0, None),
          ]),
          (re.compile(r'\]'), [
              # (terminal, group, function)
              ('rsquare', 0, None),
          ]),
          (re.compile(r'\+'), [
              # (terminal, group, function)
              ('plus', 0, None),
          ]),
          (re.compile(r'\*'), [
              # (terminal, group, function)
              ('asterisk', 0, None),
          ]),
          (re.compile(r'-'), [
              # (terminal, group, function)
              ('dash', 0, None),
          ]),
          (re.compile(r'/'), [
              # (terminal, group, function)
              ('slash', 0, None),
          ]),
          (re.compile(r'%'), [
              # (terminal, group, function)
              ('percent', 0, None),
          ]),
          (re.compile(r'<='), [
              # (terminal, group, function)
              ('lteq', 0, None),
          ]),
          (re.compile(r'<'), [
              # (terminal, group, function)
              ('lt', 0, None),
          ]),
          (re.compile(r'>='), [
              # (terminal, group, function)
              ('gteq', 0, None),
          ]),
          (re.compile(r'>'), [
              # (terminal, group, function)
              ('gt', 0, None),
          ]),
          (re.compile(r'!'), [
              # (terminal, group, function)
              ('not', 0, None),
          ]),
          (re.compile(r'\"'), [
              # (terminal, group, function)
              ('quote', 0, None),
              LexerStackPush('dquote_string'),
          ]),
          (re.compile(r'\''), [
              # (terminal, group, function)
              ('quote', 0, None),
              LexerStackPush('squote_string'),
          ]),
          (re.compile(r'\?'), [
              # (terminal, group, function)
              ('qmark', 0, None),
          ]),
          (re.compile(r'-?[0-9]+\.[0-9]+'), [
              # (terminal, group, function)
              ('float', 0, None),
          ]),
          (re.compile(r'[0-9]+'), [
              # (terminal, group, function)
              ('integer', 0, None),
          ]),
        ]),
        'dquote_string': OrderedDict([
          (re.compile(r'\"'), [
              # (terminal, group, function)
              ('quote', 0, None),
              LexerAction('pop'),
          ]),
          (re.compile(r'\$\{'), [
              # (terminal, group, function)
              ('expression_placeholder_start', 0, None),
              LexerStackPush('expression_placeholder'),
          ]),
          (re.compile(r'~\{'), [
              # (terminal, group, function)
              ('expression_placeholder_start', 0, None),
              LexerStackPush('expression_placeholder'),
          ]),
          (re.compile(r'\\[0-7][0-7][0-7]'), [
              # (terminal, group, function)
              ('escape', 0, None),
          ]),
          (re.compile(r'\\x[0-9A-Fa-f][0-9A-Fa-f]'), [
              # (terminal, group, function)
              ('escape', 0, None),
          ]),
          (re.compile(r'\\u[0-9A-Fa-f][0-9A-Fa-f][0-9A-Fa-f][0-9A-Fa-f]'), [
              # (terminal, group, function)
              ('escape', 0, None),
          ]),
          (re.compile(r'\\U[0-9A-Fa-f][0-9A-Fa-f][0-9A-Fa-f][0-9A-Fa-f][0-9A-Fa-f][0-9A-Fa-f][0-9A-Fa-f][0-9A-Fa-f]'), [
              # (terminal, group, function)
              ('escape', 0, None),
          ]),
          (re.compile(r'\\.'), [
              # (terminal, group, function)
              ('escape', 0, None),
          ]),
          (re.compile(r'[^\\\"\n(\$\{)(~\{)]*'), [
              # (terminal, group, function)
              ('string', 0, None),
          ]),
        ]),
        'squote_string': OrderedDict([
          (re.compile(r'\''), [
              # (terminal, group, function)
              ('quote', 0, None),
              LexerAction('pop'),
          ]),
          (re.compile(r'\$\{'), [
              # (terminal, group, function)
              ('expression_placeholder_start', 0, None),
              LexerStackPush('expression_placeholder'),
          ]),
          (re.compile(r'~\{'), [
              # (terminal, group, function)
              ('expression_placeholder_start', 0, None),
              LexerStackPush('expression_placeholder'),
          ]),
          (re.compile(r'\\[0-7][0-7][0-7]'), [
              # (terminal, group, function)
              ('escape', 0, None),
          ]),
          (re.compile(r'\\x[0-9A-Fa-f][0-9A-Fa-f]'), [
              # (terminal, group, function)
              ('escape', 0, None),
          ]),
          (re.compile(r'\\u[0-9A-Fa-f][0-9A-Fa-f][0-9A-Fa-f][0-9A-Fa-f]'), [
              # (terminal, group, function)
              ('escape', 0, None),
          ]),
          (re.compile(r'\\U[0-9A-Fa-f][0-9A-Fa-f][0-9A-Fa-f][0-9A-Fa-f][0-9A-Fa-f][0-9A-Fa-f][0-9A-Fa-f][0-9A-Fa-f]'), [
              # (terminal, group, function)
              ('escape', 0, None),
          ]),
          (re.compile(r'\\.'), [
              # (terminal, group, function)
              ('escape', 0, None),
          ]),
          (re.compile(r'[^\\\'\n(\$\{)(~\{)]*'), [
              # (terminal, group, function)
              ('string', 0, None),
          ]),
        ]),
        'awaiting_version_name': OrderedDict([
          (re.compile(r'\s+'), [
              # (terminal, group, function)
          ]),
          (re.compile(r'development'), [
              # (terminal, group, function)
              ('version_name', 0, None),
              LexerStackPush('main'),
          ]),
        ]),
        'task_fqn': OrderedDict([
          (re.compile(r'\s+'), [
              # (terminal, group, function)
          ]),
          (re.compile(r'[a-zA-Z]([a-zA-Z0-9_])*(\.[a-zA-Z]([a-zA-Z0-9_])*)*'), [
              # (terminal, group, function)
              ('fqn', 0, None),
              LexerAction('pop'),
          ]),
        ]),
        'scatter': OrderedDict([
          (re.compile(r'\s+'), [
              # (terminal, group, function)
          ]),
          (re.compile(r'\('), [
              # (terminal, group, function)
              ('lparen', 0, None),
          ]),
          (re.compile(r'in(?![a-zA-Z0-9_])'), [
              # (terminal, group, function)
              ('in', 0, None),
              LexerAction('pop'),
          ]),
          (re.compile(r'[a-zA-Z]([a-zA-Z0-9_])*'), [
              # (terminal, group, function)
              ('identifier', 0, None),
          ]),
        ]),
        'raw_command': OrderedDict([
          (re.compile(r'\{'), [
              # (terminal, group, function)
              ('raw_cmd_start', 0, None),
          ]),
          (re.compile(r'\}'), [
              # (terminal, group, function)
              ('raw_cmd_end', 0, None),
              LexerAction('pop'),
          ]),
          (re.compile(r'\$\{'), [
              # (terminal, group, function)
              ('expression_placeholder_start', 0, None),
              LexerStackPush('expression_placeholder'),
          ]),
          (re.compile(r'~\{'), [
              # (terminal, group, function)
              ('expression_placeholder_start', 0, None),
              LexerStackPush('expression_placeholder'),
          ]),
          (re.compile(r'(.*?)(?=\$\{|~\{|\})', re.DOTALL), [
              # (terminal, group, function)
              ('cmd_part', 0, None),
          ]),
        ]),
        'raw_command2': OrderedDict([
          (re.compile(r'<<<'), [
              # (terminal, group, function)
              ('raw_cmd_start', 0, None),
          ]),
          (re.compile(r'>>>'), [
              # (terminal, group, function)
              ('raw_cmd_end', 0, None),
              LexerAction('pop'),
          ]),
          (re.compile(r'~\{'), [
              # (terminal, group, function)
              ('expression_placeholder_start', 0, None),
              LexerStackPush('expression_placeholder'),
          ]),
          (re.compile(r'(.*?)(?=~\{|>>>)', re.DOTALL), [
              # (terminal, group, function)
              ('cmd_part', 0, None),
          ]),
        ]),
        'expression_placeholder': OrderedDict([
          (re.compile(r'\s+'), [
              # (terminal, group, function)
          ]),
          (re.compile(r'\}'), [
              # (terminal, group, function)
              ('expression_placeholder_end', 0, None),
              LexerAction('pop'),
          ]),
          (re.compile(r'\['), [
              # (terminal, group, function)
              ('lsquare', 0, None),
          ]),
          (re.compile(r'\]'), [
              # (terminal, group, function)
              ('rsquare', 0, None),
          ]),
          (re.compile(r'='), [
              # (terminal, group, function)
              ('equal', 0, None),
          ]),
          (re.compile(r'\+'), [
              # (terminal, group, function)
              ('plus', 0, None),
          ]),
          (re.compile(r'\*'), [
              # (terminal, group, function)
              ('asterisk', 0, None),
          ]),
          (re.compile(r'[0-9]+'), [
              # (terminal, group, function)
              ('integer', 0, None),
          ]),
          (re.compile(r'if'), [
              # (terminal, group, function)
              ('if', 0, None),
          ]),
          (re.compile(r'else'), [
              # (terminal, group, function)
              ('else', 0, None),
          ]),
          (re.compile(r'then'), [
              # (terminal, group, function)
              ('then', 0, None),
          ]),
          (re.compile(r'[a-zA-Z]([a-zA-Z0-9_])*(?=\s*=)'), [
              # (terminal, group, function)
              ('cmd_attr_hint', None, None),
              ('identifier', 0, None),
          ]),
          (re.compile(r'(true|false)(?![a-zA-Z0-9_])'), [
              # (terminal, group, function)
              ('boolean', 0, None),
          ]),
          (re.compile(r'(Array|Map|Object|Pair|Boolean|Int|Float|Uri|File|Directory|String)(?![a-zA-Z0-9_])(?![a-zA-Z0-9_])'), [
              # (terminal, group, function)
              ('type', 0, None),
          ]),
          (re.compile(r'[a-zA-Z]([a-zA-Z0-9_])*'), [
              # (terminal, group, function)
              ('identifier', 0, None),
          ]),
          (re.compile(r':'), [
              # (terminal, group, function)
              ('colon', 0, None),
          ]),
          (re.compile(r','), [
              # (terminal, group, function)
              ('comma', 0, None),
          ]),
          (re.compile(r'\.'), [
              # (terminal, group, function)
              ('dot', 0, None),
          ]),
          (re.compile(r'=='), [
              # (terminal, group, function)
              ('double_equal', 0, None),
          ]),
          (re.compile(r'\|\|'), [
              # (terminal, group, function)
              ('double_pipe', 0, None),
          ]),
          (re.compile(r'\&\&'), [
              # (terminal, group, function)
              ('double_ampersand', 0, None),
          ]),
          (re.compile(r'!='), [
              # (terminal, group, function)
              ('not_equal', 0, None),
          ]),
          (re.compile(r'='), [
              # (terminal, group, function)
              ('equal', 0, None),
          ]),
          (re.compile(r'\.'), [
              # (terminal, group, function)
              ('dot', 0, None),
          ]),
          (re.compile(r'\{'), [
              # (terminal, group, function)
              ('lbrace', 0, None),
          ]),
          (re.compile(r'\('), [
              # (terminal, group, function)
              ('lparen', 0, None),
          ]),
          (re.compile(r'\)'), [
              # (terminal, group, function)
              ('rparen', 0, None),
          ]),
          (re.compile(r'\['), [
              # (terminal, group, function)
              ('lsquare', 0, None),
          ]),
          (re.compile(r'\]'), [
              # (terminal, group, function)
              ('rsquare', 0, None),
          ]),
          (re.compile(r'\+'), [
              # (terminal, group, function)
              ('plus', 0, None),
          ]),
          (re.compile(r'\*'), [
              # (terminal, group, function)
              ('asterisk', 0, None),
          ]),
          (re.compile(r'-'), [
              # (terminal, group, function)
              ('dash', 0, None),
          ]),
          (re.compile(r'/'), [
              # (terminal, group, function)
              ('slash', 0, None),
          ]),
          (re.compile(r'%'), [
              # (terminal, group, function)
              ('percent', 0, None),
          ]),
          (re.compile(r'<='), [
              # (terminal, group, function)
              ('lteq', 0, None),
          ]),
          (re.compile(r'<'), [
              # (terminal, group, function)
              ('lt', 0, None),
          ]),
          (re.compile(r'>='), [
              # (terminal, group, function)
              ('gteq', 0, None),
          ]),
          (re.compile(r'>'), [
              # (terminal, group, function)
              ('gt', 0, None),
          ]),
          (re.compile(r'!'), [
              # (terminal, group, function)
              ('not', 0, None),
          ]),
          (re.compile(r'\"'), [
              # (terminal, group, function)
              ('quote', 0, None),
              LexerStackPush('dquote_string'),
          ]),
          (re.compile(r'\''), [
              # (terminal, group, function)
              ('quote', 0, None),
              LexerStackPush('squote_string'),
          ]),
          (re.compile(r'-?[0-9]+\.[0-9]+'), [
              # (terminal, group, function)
              ('float', 0, None),
          ]),
          (re.compile(r'[0-9]+'), [
              # (terminal, group, function)
              ('integer', 0, None),
          ]),
        ]),
    }
    def _advance_line_col(self, string, length, line, col):
        for i in range(length):
            if string[i] == '\n':
                line += 1
                col = 1
            else:
                col += 1
        return (line, col)
    def _advance_string(self, ctx, string):
        (ctx.line, ctx.col) = self._advance_line_col(string, len(string), ctx.line, ctx.col)
        ctx.string = ctx.string[len(string):]
    def _next(self, ctx, debug=False):
        for regex, outputs in self.regex[ctx.stack[-1]].items():
            if debug:
                from xtermcolor import colorize
                token_count = len(ctx.tokens)
                print('{1} ({2}, {3}) regex: {0}'.format(
                    colorize(regex.pattern, ansi=40), colorize(ctx.string[:20].replace('\n', '\\n'), ansi=15), ctx.line, ctx.col)
                )
            match = regex.match(ctx.string)
            if match:
                ctx.re_match = match
                for output in outputs:
                    if isinstance(output, tuple):
                        (terminal, group, function) = output
                        function = function if function else default_action
                        source_string = match.group(group) if group is not None else ''
                        (group_line, group_col) = self._advance_line_col(ctx.string, match.start(group) if group else 0, ctx.line, ctx.col)
                        function(
                            ctx,
                            terminal,
                            source_string,
                            group_line,
                            group_col
                        )
                        if debug:
                            print('    matched: {}'.format(colorize(match.group(0).replace('\n', '\\n'), ansi=3)))
                            for token in ctx.tokens[token_count:]:
                                print('    emit: [{}] [{}, {}] [{}] stack:{} context:{}'.format(
                                    colorize(token.str, ansi=9),
                                    colorize(str(token.line), ansi=5),
                                    colorize(str(token.col), ansi=5),
                                    colorize(token.source_string, ansi=3),
                                    colorize(str(ctx.stack), ansi=4),
                                    colorize(str(ctx.user_context), ansi=13)
                                ))
                            token_count = len(ctx.tokens)
                    if isinstance(output, LexerStackPush):
                        ctx.stack.append(output.mode)
                        if debug:
                            print('    push on stack: {}'.format(colorize(output.mode, ansi=4)))
                    if isinstance(output, LexerAction):
                        if output.action == 'pop':
                            mode = ctx.stack.pop()
                            if debug:
                                print('    pop off stack: {}'.format(colorize(mode, ansi=4)))
                self._advance_string(ctx, match.group(0))
                return len(match.group(0)) > 0
        return False
    def lex(self, string, resource, errors=None, debug=False):
        if errors is None:
            errors = DefaultSyntaxErrorHandler()
        string_copy = string
        user_context = init()
        ctx = LexerContext(string, resource, errors, user_context)
        while len(ctx.string):
            matched = self._next(ctx, debug)
            if matched == False:
                raise ctx.errors.unrecognized_token(string_copy, ctx.line, ctx.col)
        destroy(ctx.user_context)
        filtered = post_filter(ctx.tokens)
        return filtered
def lex(source, resource, errors=None, debug=False):
    return TokenStream(HermesLexer().lex(source, resource, errors, debug))
